FROM node:18 AS build


RUN apt-get update && apt-get install -y \
    unzip \ 
    python3-pip 

RUN curl -LO https://github.com/protocolbuffers/protobuf/releases/download/v3.19.4/protoc-3.19.4-linux-x86_64.zip && \
    unzip protoc-3.19.4-linux-x86_64.zip -d /usr/local

RUN npm install -g google-protobuf typescript protoc-gen-ts 

COPY --from=golang:1.18 /usr/local/go /usr/local/go
ENV GOPATH="/usr/local/go"
ENV PATH="/usr/local/go/bin:${PATH}"

RUN go install google.golang.org/protobuf/cmd/protoc-gen-go@latest && \
    go install google.golang.org/grpc/cmd/protoc-gen-go-grpc@latest

COPY ./requirements /requirements
RUN pip3 install -r /requirements && rm /requirements

COPY ./grpc_csharp_plugin /usr/local/bin
