// package: base
// file: avvyprotocol/base.proto

import * as jspb from "google-protobuf";

export class Cid extends jspb.Message {
  getValue(): Uint8Array | string;
  getValue_asU8(): Uint8Array;
  getValue_asB64(): string;
  setValue(value: Uint8Array | string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): Cid.AsObject;
  static toObject(includeInstance: boolean, msg: Cid): Cid.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: Cid, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): Cid;
  static deserializeBinaryFromReader(message: Cid, reader: jspb.BinaryReader): Cid;
}

export namespace Cid {
  export type AsObject = {
    value: Uint8Array | string,
  }
}

export class Uid extends jspb.Message {
  getValue(): Uint8Array | string;
  getValue_asU8(): Uint8Array;
  getValue_asB64(): string;
  setValue(value: Uint8Array | string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): Uid.AsObject;
  static toObject(includeInstance: boolean, msg: Uid): Uid.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: Uid, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): Uid;
  static deserializeBinaryFromReader(message: Uid, reader: jspb.BinaryReader): Uid;
}

export namespace Uid {
  export type AsObject = {
    value: Uint8Array | string,
  }
}

export class Tags extends jspb.Message {
  clearValuesList(): void;
  getValuesList(): Array<string>;
  setValuesList(value: Array<string>): void;
  addValues(value: string, index?: number): string;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): Tags.AsObject;
  static toObject(includeInstance: boolean, msg: Tags): Tags.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: Tags, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): Tags;
  static deserializeBinaryFromReader(message: Tags, reader: jspb.BinaryReader): Tags;
}

export namespace Tags {
  export type AsObject = {
    valuesList: Array<string>,
  }
}

export class UserTags extends jspb.Message {
  getLanguage(): string;
  setLanguage(value: string): void;

  clearValuesList(): void;
  getValuesList(): Array<string>;
  setValuesList(value: Array<string>): void;
  addValues(value: string, index?: number): string;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): UserTags.AsObject;
  static toObject(includeInstance: boolean, msg: UserTags): UserTags.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: UserTags, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): UserTags;
  static deserializeBinaryFromReader(message: UserTags, reader: jspb.BinaryReader): UserTags;
}

export namespace UserTags {
  export type AsObject = {
    language: string,
    valuesList: Array<string>,
  }
}

export class Data extends jspb.Message {
  clearDatabytesList(): void;
  getDatabytesList(): Array<Uint8Array | string>;
  getDatabytesList_asU8(): Array<Uint8Array>;
  getDatabytesList_asB64(): Array<string>;
  setDatabytesList(value: Array<Uint8Array | string>): void;
  addDatabytes(value: Uint8Array | string, index?: number): Uint8Array | string;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): Data.AsObject;
  static toObject(includeInstance: boolean, msg: Data): Data.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: Data, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): Data;
  static deserializeBinaryFromReader(message: Data, reader: jspb.BinaryReader): Data;
}

export namespace Data {
  export type AsObject = {
    databytesList: Array<Uint8Array | string>,
  }
}

export class BloomFilterArgs extends jspb.Message {
  getInitialized(): boolean;
  setInitialized(value: boolean): void;

  getCapacity(): number;
  setCapacity(value: number): void;

  getErrorrate(): number;
  setErrorrate(value: number): void;

  getFiltersize(): number;
  setFiltersize(value: number): void;

  getHashfunctioncount(): number;
  setHashfunctioncount(value: number): void;

  getHashbits(): Uint8Array | string;
  getHashbits_asU8(): Uint8Array;
  getHashbits_asB64(): string;
  setHashbits(value: Uint8Array | string): void;

  getUseadditionalhash(): boolean;
  setUseadditionalhash(value: boolean): void;

  getDeletesallowed(): boolean;
  setDeletesallowed(value: boolean): void;

  getDeletescollisionmask(): Uint8Array | string;
  getDeletescollisionmask_asU8(): Uint8Array;
  getDeletescollisionmask_asB64(): string;
  setDeletescollisionmask(value: Uint8Array | string): void;

  getCidchunksize(): number;
  setCidchunksize(value: number): void;

  getCollisionbits(): Uint8Array | string;
  getCollisionbits_asU8(): Uint8Array;
  getCollisionbits_asB64(): string;
  setCollisionbits(value: Uint8Array | string): void;

  getCollisionfiltersize(): number;
  setCollisionfiltersize(value: number): void;

  getCount(): number;
  setCount(value: number): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): BloomFilterArgs.AsObject;
  static toObject(includeInstance: boolean, msg: BloomFilterArgs): BloomFilterArgs.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: BloomFilterArgs, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): BloomFilterArgs;
  static deserializeBinaryFromReader(message: BloomFilterArgs, reader: jspb.BinaryReader): BloomFilterArgs;
}

export namespace BloomFilterArgs {
  export type AsObject = {
    initialized: boolean,
    capacity: number,
    errorrate: number,
    filtersize: number,
    hashfunctioncount: number,
    hashbits: Uint8Array | string,
    useadditionalhash: boolean,
    deletesallowed: boolean,
    deletescollisionmask: Uint8Array | string,
    cidchunksize: number,
    collisionbits: Uint8Array | string,
    collisionfiltersize: number,
    count: number,
  }
}

export class WaitWorkerUUID extends jspb.Message {
  getValue(): Uint8Array | string;
  getValue_asU8(): Uint8Array;
  getValue_asB64(): string;
  setValue(value: Uint8Array | string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): WaitWorkerUUID.AsObject;
  static toObject(includeInstance: boolean, msg: WaitWorkerUUID): WaitWorkerUUID.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: WaitWorkerUUID, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): WaitWorkerUUID;
  static deserializeBinaryFromReader(message: WaitWorkerUUID, reader: jspb.BinaryReader): WaitWorkerUUID;
}

export namespace WaitWorkerUUID {
  export type AsObject = {
    value: Uint8Array | string,
  }
}

