// package: l2
// file: avvyprotocol/l2_api.proto

import * as jspb from "google-protobuf";
import * as avvyprotocol_l2_object_pb from "../avvyprotocol/l2_object_pb";
import * as avvyprotocol_l2_value_pb from "../avvyprotocol/l2_value_pb";
import * as avvyprotocol_l2_uco_pb from "../avvyprotocol/l2_uco_pb";
import * as avvyprotocol_ucsmodel_pb from "../avvyprotocol/ucsmodel_pb";

export class Empty extends jspb.Message {
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): Empty.AsObject;
  static toObject(includeInstance: boolean, msg: Empty): Empty.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: Empty, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): Empty;
  static deserializeBinaryFromReader(message: Empty, reader: jspb.BinaryReader): Empty;
}

export namespace Empty {
  export type AsObject = {
  }
}

export class Error extends jspb.Message {
  getCode(): number;
  setCode(value: number): void;

  getError(): string;
  setError(value: string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): Error.AsObject;
  static toObject(includeInstance: boolean, msg: Error): Error.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: Error, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): Error;
  static deserializeBinaryFromReader(message: Error, reader: jspb.BinaryReader): Error;
}

export namespace Error {
  export type AsObject = {
    code: number,
    error: string,
  }
}

export class L2Request extends jspb.Message {
  getRequestId(): number;
  setRequestId(value: number): void;

  hasTxn(): boolean;
  clearTxn(): void;
  getTxn(): avvyprotocol_l2_object_pb.Txn | undefined;
  setTxn(value?: avvyprotocol_l2_object_pb.Txn): void;

  hasAssetquery(): boolean;
  clearAssetquery(): void;
  getAssetquery(): avvyprotocol_l2_uco_pb.AssetQuery | undefined;
  setAssetquery(value?: avvyprotocol_l2_uco_pb.AssetQuery): void;

  getPayloadCase(): L2Request.PayloadCase;
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): L2Request.AsObject;
  static toObject(includeInstance: boolean, msg: L2Request): L2Request.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: L2Request, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): L2Request;
  static deserializeBinaryFromReader(message: L2Request, reader: jspb.BinaryReader): L2Request;
}

export namespace L2Request {
  export type AsObject = {
    requestId: number,
    txn?: avvyprotocol_l2_object_pb.Txn.AsObject,
    assetquery?: avvyprotocol_l2_uco_pb.AssetQuery.AsObject,
  }

  export enum PayloadCase {
    PAYLOAD_NOT_SET = 0,
    TXN = 2,
    ASSETQUERY = 3,
  }
}

export class L2Response extends jspb.Message {
  getRequestId(): number;
  setRequestId(value: number): void;

  hasError(): boolean;
  clearError(): void;
  getError(): Error | undefined;
  setError(value?: Error): void;

  hasResponse(): boolean;
  clearResponse(): void;
  getResponse(): avvyprotocol_l2_value_pb.PropMap | undefined;
  setResponse(value?: avvyprotocol_l2_value_pb.PropMap): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): L2Response.AsObject;
  static toObject(includeInstance: boolean, msg: L2Response): L2Response.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: L2Response, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): L2Response;
  static deserializeBinaryFromReader(message: L2Response, reader: jspb.BinaryReader): L2Response;
}

export namespace L2Response {
  export type AsObject = {
    requestId: number,
    error?: Error.AsObject,
    response?: avvyprotocol_l2_value_pb.PropMap.AsObject,
  }
}

export class L2Event extends jspb.Message {
  hasObject(): boolean;
  clearObject(): void;
  getObject(): avvyprotocol_l2_object_pb.ObjectDigest | undefined;
  setObject(value?: avvyprotocol_l2_object_pb.ObjectDigest): void;

  hasError(): boolean;
  clearError(): void;
  getError(): Error | undefined;
  setError(value?: Error): void;

  getEventCase(): L2Event.EventCase;
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): L2Event.AsObject;
  static toObject(includeInstance: boolean, msg: L2Event): L2Event.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: L2Event, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): L2Event;
  static deserializeBinaryFromReader(message: L2Event, reader: jspb.BinaryReader): L2Event;
}

export namespace L2Event {
  export type AsObject = {
    object?: avvyprotocol_l2_object_pb.ObjectDigest.AsObject,
    error?: Error.AsObject,
  }

  export enum EventCase {
    EVENT_NOT_SET = 0,
    OBJECT = 1,
    ERROR = 2,
  }
}

export class L2Content extends jspb.Message {
  hasStaticcontent(): boolean;
  clearStaticcontent(): void;
  getStaticcontent(): avvyprotocol_ucsmodel_pb.StaticContent | undefined;
  setStaticcontent(value?: avvyprotocol_ucsmodel_pb.StaticContent): void;

  hasError(): boolean;
  clearError(): void;
  getError(): Error | undefined;
  setError(value?: Error): void;

  getContentCase(): L2Content.ContentCase;
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): L2Content.AsObject;
  static toObject(includeInstance: boolean, msg: L2Content): L2Content.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: L2Content, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): L2Content;
  static deserializeBinaryFromReader(message: L2Content, reader: jspb.BinaryReader): L2Content;
}

export namespace L2Content {
  export type AsObject = {
    staticcontent?: avvyprotocol_ucsmodel_pb.StaticContent.AsObject,
    error?: Error.AsObject,
  }

  export enum ContentCase {
    CONTENT_NOT_SET = 0,
    STATICCONTENT = 1,
    ERROR = 2,
  }
}

