// package: l2
// file: avvyprotocol/l2_api.proto

import * as avvyprotocol_l2_api_pb from "../avvyprotocol/l2_api_pb";
import {grpc} from "@improbable-eng/grpc-web";

type L2ServiceRequest = {
  readonly methodName: string;
  readonly service: typeof L2Service;
  readonly requestStream: false;
  readonly responseStream: false;
  readonly requestType: typeof avvyprotocol_l2_api_pb.L2Request;
  readonly responseType: typeof avvyprotocol_l2_api_pb.L2Response;
};

type L2ServiceStream = {
  readonly methodName: string;
  readonly service: typeof L2Service;
  readonly requestStream: true;
  readonly responseStream: false;
  readonly requestType: typeof avvyprotocol_l2_api_pb.L2Request;
  readonly responseType: typeof avvyprotocol_l2_api_pb.L2Response;
};

type L2ServiceEventBus = {
  readonly methodName: string;
  readonly service: typeof L2Service;
  readonly requestStream: false;
  readonly responseStream: true;
  readonly requestType: typeof avvyprotocol_l2_api_pb.Empty;
  readonly responseType: typeof avvyprotocol_l2_api_pb.L2Event;
};

type L2ServiceContentBus = {
  readonly methodName: string;
  readonly service: typeof L2Service;
  readonly requestStream: false;
  readonly responseStream: true;
  readonly requestType: typeof avvyprotocol_l2_api_pb.Empty;
  readonly responseType: typeof avvyprotocol_l2_api_pb.L2Content;
};

export class L2Service {
  static readonly serviceName: string;
  static readonly Request: L2ServiceRequest;
  static readonly Stream: L2ServiceStream;
  static readonly EventBus: L2ServiceEventBus;
  static readonly ContentBus: L2ServiceContentBus;
}

export type ServiceError = { message: string, code: number; metadata: grpc.Metadata }
export type Status = { details: string, code: number; metadata: grpc.Metadata }

interface UnaryResponse {
  cancel(): void;
}
interface ResponseStream<T> {
  cancel(): void;
  on(type: 'data', handler: (message: T) => void): ResponseStream<T>;
  on(type: 'end', handler: (status?: Status) => void): ResponseStream<T>;
  on(type: 'status', handler: (status: Status) => void): ResponseStream<T>;
}
interface RequestStream<T> {
  write(message: T): RequestStream<T>;
  end(): void;
  cancel(): void;
  on(type: 'end', handler: (status?: Status) => void): RequestStream<T>;
  on(type: 'status', handler: (status: Status) => void): RequestStream<T>;
}
interface BidirectionalStream<ReqT, ResT> {
  write(message: ReqT): BidirectionalStream<ReqT, ResT>;
  end(): void;
  cancel(): void;
  on(type: 'data', handler: (message: ResT) => void): BidirectionalStream<ReqT, ResT>;
  on(type: 'end', handler: (status?: Status) => void): BidirectionalStream<ReqT, ResT>;
  on(type: 'status', handler: (status: Status) => void): BidirectionalStream<ReqT, ResT>;
}

export class L2ServiceClient {
  readonly serviceHost: string;

  constructor(serviceHost: string, options?: grpc.RpcOptions);
  request(
    requestMessage: avvyprotocol_l2_api_pb.L2Request,
    metadata: grpc.Metadata,
    callback: (error: ServiceError|null, responseMessage: avvyprotocol_l2_api_pb.L2Response|null) => void
  ): UnaryResponse;
  request(
    requestMessage: avvyprotocol_l2_api_pb.L2Request,
    callback: (error: ServiceError|null, responseMessage: avvyprotocol_l2_api_pb.L2Response|null) => void
  ): UnaryResponse;
  stream(metadata?: grpc.Metadata): RequestStream<avvyprotocol_l2_api_pb.L2Request>;
  eventBus(requestMessage: avvyprotocol_l2_api_pb.Empty, metadata?: grpc.Metadata): ResponseStream<avvyprotocol_l2_api_pb.L2Event>;
  contentBus(requestMessage: avvyprotocol_l2_api_pb.Empty, metadata?: grpc.Metadata): ResponseStream<avvyprotocol_l2_api_pb.L2Content>;
}

