// package: l2
// file: avvyprotocol/l2_object.proto

import * as jspb from "google-protobuf";
import * as avvyprotocol_l2_value_pb from "../avvyprotocol/l2_value_pb";

export class AvvyObject extends jspb.Message {
  getUid(): Uint8Array | string;
  getUid_asU8(): Uint8Array;
  getUid_asB64(): string;
  setUid(value: Uint8Array | string): void;

  getParent(): Uint8Array | string;
  getParent_asU8(): Uint8Array;
  getParent_asB64(): string;
  setParent(value: Uint8Array | string): void;

  clearTransformationList(): void;
  getTransformationList(): Array<number>;
  setTransformationList(value: Array<number>): void;
  addTransformation(value: number, index?: number): number;

  clearPrototypesList(): void;
  getPrototypesList(): Array<Uint8Array | string>;
  getPrototypesList_asU8(): Array<Uint8Array>;
  getPrototypesList_asB64(): Array<string>;
  setPrototypesList(value: Array<Uint8Array | string>): void;
  addPrototypes(value: Uint8Array | string, index?: number): Uint8Array | string;

  clearBlockcellsList(): void;
  getBlockcellsList(): Array<Blockcell>;
  setBlockcellsList(value: Array<Blockcell>): void;
  addBlockcells(value?: Blockcell, index?: number): Blockcell;

  clearChildrenList(): void;
  getChildrenList(): Array<Uint8Array | string>;
  getChildrenList_asU8(): Array<Uint8Array>;
  getChildrenList_asB64(): Array<string>;
  setChildrenList(value: Array<Uint8Array | string>): void;
  addChildren(value: Uint8Array | string, index?: number): Uint8Array | string;

  hasProperties(): boolean;
  clearProperties(): void;
  getProperties(): avvyprotocol_l2_value_pb.PropMap | undefined;
  setProperties(value?: avvyprotocol_l2_value_pb.PropMap): void;

  getNonce(): number;
  setNonce(value: number): void;

  clearViewsList(): void;
  getViewsList(): Array<Uint8Array | string>;
  getViewsList_asU8(): Array<Uint8Array>;
  getViewsList_asB64(): Array<string>;
  setViewsList(value: Array<Uint8Array | string>): void;
  addViews(value: Uint8Array | string, index?: number): Uint8Array | string;

  getCurrentview(): Uint8Array | string;
  getCurrentview_asU8(): Uint8Array;
  getCurrentview_asB64(): string;
  setCurrentview(value: Uint8Array | string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): AvvyObject.AsObject;
  static toObject(includeInstance: boolean, msg: AvvyObject): AvvyObject.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: AvvyObject, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): AvvyObject;
  static deserializeBinaryFromReader(message: AvvyObject, reader: jspb.BinaryReader): AvvyObject;
}

export namespace AvvyObject {
  export type AsObject = {
    uid: Uint8Array | string,
    parent: Uint8Array | string,
    transformationList: Array<number>,
    prototypesList: Array<Uint8Array | string>,
    blockcellsList: Array<Blockcell.AsObject>,
    childrenList: Array<Uint8Array | string>,
    properties?: avvyprotocol_l2_value_pb.PropMap.AsObject,
    nonce: number,
    viewsList: Array<Uint8Array | string>,
    currentview: Uint8Array | string,
  }
}

export class Blockcell extends jspb.Message {
  getIndex(): number;
  setIndex(value: number): void;

  hasProps(): boolean;
  clearProps(): void;
  getProps(): avvyprotocol_l2_value_pb.PropMap | undefined;
  setProps(value?: avvyprotocol_l2_value_pb.PropMap): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): Blockcell.AsObject;
  static toObject(includeInstance: boolean, msg: Blockcell): Blockcell.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: Blockcell, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): Blockcell;
  static deserializeBinaryFromReader(message: Blockcell, reader: jspb.BinaryReader): Blockcell;
}

export namespace Blockcell {
  export type AsObject = {
    index: number,
    props?: avvyprotocol_l2_value_pb.PropMap.AsObject,
  }
}

export class ObjectDigest extends jspb.Message {
  getUid(): Uint8Array | string;
  getUid_asU8(): Uint8Array;
  getUid_asB64(): string;
  setUid(value: Uint8Array | string): void;

  getParent(): Uint8Array | string;
  getParent_asU8(): Uint8Array;
  getParent_asB64(): string;
  setParent(value: Uint8Array | string): void;

  clearTransformationList(): void;
  getTransformationList(): Array<number>;
  setTransformationList(value: Array<number>): void;
  addTransformation(value: number, index?: number): number;

  hasPayload(): boolean;
  clearPayload(): void;
  getPayload(): avvyprotocol_l2_value_pb.PropMap | undefined;
  setPayload(value?: avvyprotocol_l2_value_pb.PropMap): void;

  clearChildrenList(): void;
  getChildrenList(): Array<Uint8Array | string>;
  getChildrenList_asU8(): Array<Uint8Array>;
  getChildrenList_asB64(): Array<string>;
  setChildrenList(value: Array<Uint8Array | string>): void;
  addChildren(value: Uint8Array | string, index?: number): Uint8Array | string;

  getCurrentview(): Uint8Array | string;
  getCurrentview_asU8(): Uint8Array;
  getCurrentview_asB64(): string;
  setCurrentview(value: Uint8Array | string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ObjectDigest.AsObject;
  static toObject(includeInstance: boolean, msg: ObjectDigest): ObjectDigest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ObjectDigest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ObjectDigest;
  static deserializeBinaryFromReader(message: ObjectDigest, reader: jspb.BinaryReader): ObjectDigest;
}

export namespace ObjectDigest {
  export type AsObject = {
    uid: Uint8Array | string,
    parent: Uint8Array | string,
    transformationList: Array<number>,
    payload?: avvyprotocol_l2_value_pb.PropMap.AsObject,
    childrenList: Array<Uint8Array | string>,
    currentview: Uint8Array | string,
  }
}

export class Txn extends jspb.Message {
  hasMessage(): boolean;
  clearMessage(): void;
  getMessage(): Message | undefined;
  setMessage(value?: Message): void;

  getSignature(): Uint8Array | string;
  getSignature_asU8(): Uint8Array;
  getSignature_asB64(): string;
  setSignature(value: Uint8Array | string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): Txn.AsObject;
  static toObject(includeInstance: boolean, msg: Txn): Txn.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: Txn, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): Txn;
  static deserializeBinaryFromReader(message: Txn, reader: jspb.BinaryReader): Txn;
}

export namespace Txn {
  export type AsObject = {
    message?: Message.AsObject,
    signature: Uint8Array | string,
  }
}

export class Message extends jspb.Message {
  getTarget(): Uint8Array | string;
  getTarget_asU8(): Uint8Array;
  getTarget_asB64(): string;
  setTarget(value: Uint8Array | string): void;

  getSender(): Uint8Array | string;
  getSender_asU8(): Uint8Array;
  getSender_asB64(): string;
  setSender(value: Uint8Array | string): void;

  getHandler(): string;
  setHandler(value: string): void;

  getGaslimit(): Uint8Array | string;
  getGaslimit_asU8(): Uint8Array;
  getGaslimit_asB64(): string;
  setGaslimit(value: Uint8Array | string): void;

  hasContext(): boolean;
  clearContext(): void;
  getContext(): avvyprotocol_l2_value_pb.PropMap | undefined;
  setContext(value?: avvyprotocol_l2_value_pb.PropMap): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): Message.AsObject;
  static toObject(includeInstance: boolean, msg: Message): Message.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: Message, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): Message;
  static deserializeBinaryFromReader(message: Message, reader: jspb.BinaryReader): Message;
}

export namespace Message {
  export type AsObject = {
    target: Uint8Array | string,
    sender: Uint8Array | string,
    handler: string,
    gaslimit: Uint8Array | string,
    context?: avvyprotocol_l2_value_pb.PropMap.AsObject,
  }
}

