// package: l2
// file: avvyprotocol/l2_storage.proto

import * as jspb from "google-protobuf";
import * as avvyprotocol_l2_object_pb from "../avvyprotocol/l2_object_pb";

export class Ledger extends jspb.Message {
  clearItemsList(): void;
  getItemsList(): Array<LedgerItem>;
  setItemsList(value: Array<LedgerItem>): void;
  addItems(value?: LedgerItem, index?: number): LedgerItem;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): Ledger.AsObject;
  static toObject(includeInstance: boolean, msg: Ledger): Ledger.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: Ledger, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): Ledger;
  static deserializeBinaryFromReader(message: Ledger, reader: jspb.BinaryReader): Ledger;
}

export namespace Ledger {
  export type AsObject = {
    itemsList: Array<LedgerItem.AsObject>,
  }
}

export class LedgerItem extends jspb.Message {
  getUid(): Uint8Array | string;
  getUid_asU8(): Uint8Array;
  getUid_asB64(): string;
  setUid(value: Uint8Array | string): void;

  getBalance(): Uint8Array | string;
  getBalance_asU8(): Uint8Array;
  getBalance_asB64(): string;
  setBalance(value: Uint8Array | string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): LedgerItem.AsObject;
  static toObject(includeInstance: boolean, msg: LedgerItem): LedgerItem.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: LedgerItem, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): LedgerItem;
  static deserializeBinaryFromReader(message: LedgerItem, reader: jspb.BinaryReader): LedgerItem;
}

export namespace LedgerItem {
  export type AsObject = {
    uid: Uint8Array | string,
    balance: Uint8Array | string,
  }
}

export class Snapshot extends jspb.Message {
  getFromheight(): number;
  setFromheight(value: number): void;

  getToheight(): number;
  setToheight(value: number): void;

  clearItemsList(): void;
  getItemsList(): Array<SnapshotItem>;
  setItemsList(value: Array<SnapshotItem>): void;
  addItems(value?: SnapshotItem, index?: number): SnapshotItem;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): Snapshot.AsObject;
  static toObject(includeInstance: boolean, msg: Snapshot): Snapshot.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: Snapshot, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): Snapshot;
  static deserializeBinaryFromReader(message: Snapshot, reader: jspb.BinaryReader): Snapshot;
}

export namespace Snapshot {
  export type AsObject = {
    fromheight: number,
    toheight: number,
    itemsList: Array<SnapshotItem.AsObject>,
  }
}

export class SnapshotItem extends jspb.Message {
  hasData(): boolean;
  clearData(): void;
  getData(): avvyprotocol_l2_object_pb.AvvyObject | undefined;
  setData(value?: avvyprotocol_l2_object_pb.AvvyObject): void;

  getHeight(): number;
  setHeight(value: number): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): SnapshotItem.AsObject;
  static toObject(includeInstance: boolean, msg: SnapshotItem): SnapshotItem.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: SnapshotItem, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): SnapshotItem;
  static deserializeBinaryFromReader(message: SnapshotItem, reader: jspb.BinaryReader): SnapshotItem;
}

export namespace SnapshotItem {
  export type AsObject = {
    data?: avvyprotocol_l2_object_pb.AvvyObject.AsObject,
    height: number,
  }
}

