// package: l2
// file: avvyprotocol/l2_value.proto

import * as jspb from "google-protobuf";

export class Value extends jspb.Message {
  hasDecimalvalue(): boolean;
  clearDecimalvalue(): void;
  getDecimalvalue(): Uint8Array | string;
  getDecimalvalue_asU8(): Uint8Array;
  getDecimalvalue_asB64(): string;
  setDecimalvalue(value: Uint8Array | string): void;

  hasStringvalue(): boolean;
  clearStringvalue(): void;
  getStringvalue(): string;
  setStringvalue(value: string): void;

  hasMapvalue(): boolean;
  clearMapvalue(): void;
  getMapvalue(): PropMap | undefined;
  setMapvalue(value?: PropMap): void;

  hasListvalue(): boolean;
  clearListvalue(): void;
  getListvalue(): PropList | undefined;
  setListvalue(value?: PropList): void;

  hasNodevalue(): boolean;
  clearNodevalue(): void;
  getNodevalue(): ASTNode | undefined;
  setNodevalue(value?: ASTNode): void;

  hasRefvalue(): boolean;
  clearRefvalue(): void;
  getRefvalue(): Uint8Array | string;
  getRefvalue_asU8(): Uint8Array;
  getRefvalue_asB64(): string;
  setRefvalue(value: Uint8Array | string): void;

  hasBoolvalue(): boolean;
  clearBoolvalue(): void;
  getBoolvalue(): boolean;
  setBoolvalue(value: boolean): void;

  getValueCase(): Value.ValueCase;
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): Value.AsObject;
  static toObject(includeInstance: boolean, msg: Value): Value.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: Value, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): Value;
  static deserializeBinaryFromReader(message: Value, reader: jspb.BinaryReader): Value;
}

export namespace Value {
  export type AsObject = {
    decimalvalue: Uint8Array | string,
    stringvalue: string,
    mapvalue?: PropMap.AsObject,
    listvalue?: PropList.AsObject,
    nodevalue?: ASTNode.AsObject,
    refvalue: Uint8Array | string,
    boolvalue: boolean,
  }

  export enum ValueCase {
    VALUE_NOT_SET = 0,
    DECIMALVALUE = 1,
    STRINGVALUE = 3,
    MAPVALUE = 5,
    LISTVALUE = 6,
    NODEVALUE = 7,
    REFVALUE = 9,
    BOOLVALUE = 10,
  }
}

export class PropList extends jspb.Message {
  clearItemsList(): void;
  getItemsList(): Array<Value>;
  setItemsList(value: Array<Value>): void;
  addItems(value?: Value, index?: number): Value;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): PropList.AsObject;
  static toObject(includeInstance: boolean, msg: PropList): PropList.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: PropList, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): PropList;
  static deserializeBinaryFromReader(message: PropList, reader: jspb.BinaryReader): PropList;
}

export namespace PropList {
  export type AsObject = {
    itemsList: Array<Value.AsObject>,
  }
}

export class PropMap extends jspb.Message {
  clearItemsList(): void;
  getItemsList(): Array<PropEntry>;
  setItemsList(value: Array<PropEntry>): void;
  addItems(value?: PropEntry, index?: number): PropEntry;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): PropMap.AsObject;
  static toObject(includeInstance: boolean, msg: PropMap): PropMap.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: PropMap, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): PropMap;
  static deserializeBinaryFromReader(message: PropMap, reader: jspb.BinaryReader): PropMap;
}

export namespace PropMap {
  export type AsObject = {
    itemsList: Array<PropEntry.AsObject>,
  }
}

export class PropEntry extends jspb.Message {
  getName(): string;
  setName(value: string): void;

  hasValue(): boolean;
  clearValue(): void;
  getValue(): Value | undefined;
  setValue(value?: Value): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): PropEntry.AsObject;
  static toObject(includeInstance: boolean, msg: PropEntry): PropEntry.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: PropEntry, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): PropEntry;
  static deserializeBinaryFromReader(message: PropEntry, reader: jspb.BinaryReader): PropEntry;
}

export namespace PropEntry {
  export type AsObject = {
    name: string,
    value?: Value.AsObject,
  }
}

export class ASTNode extends jspb.Message {
  hasDefaultvalue(): boolean;
  clearDefaultvalue(): void;
  getDefaultvalue(): Value | undefined;
  setDefaultvalue(value?: Value): void;

  hasGetprop(): boolean;
  clearGetprop(): void;
  getGetprop(): ASTNodeGetProp | undefined;
  setGetprop(value?: ASTNodeGetProp): void;

  hasSetprop(): boolean;
  clearSetprop(): void;
  getSetprop(): ASTNodeSetProp | undefined;
  setSetprop(value?: ASTNodeSetProp): void;

  hasGetcontext(): boolean;
  clearGetcontext(): void;
  getGetcontext(): ASTNodeGetContext | undefined;
  setGetcontext(value?: ASTNodeGetContext): void;

  hasSetcontext(): boolean;
  clearSetcontext(): void;
  getSetcontext(): ASTNodeSetContext | undefined;
  setSetcontext(value?: ASTNodeSetContext): void;

  hasProtectedprop(): boolean;
  clearProtectedprop(): void;
  getProtectedprop(): ASTNodeProtectedProp | undefined;
  setProtectedprop(value?: ASTNodeProtectedProp): void;

  hasSendmessage(): boolean;
  clearSendmessage(): void;
  getSendmessage(): ASTNodeSendMessage | undefined;
  setSendmessage(value?: ASTNodeSendMessage): void;

  hasSendevent(): boolean;
  clearSendevent(): void;
  getSendevent(): ASTNodeSendEvent | undefined;
  setSendevent(value?: ASTNodeSendEvent): void;

  hasSend(): boolean;
  clearSend(): void;
  getSend(): ASTNodeSend | undefined;
  setSend(value?: ASTNodeSend): void;

  hasCreateobject(): boolean;
  clearCreateobject(): void;
  getCreateobject(): ASTNodeCreateObject | undefined;
  setCreateobject(value?: ASTNodeCreateObject): void;

  hasTransform(): boolean;
  clearTransform(): void;
  getTransform(): ASTNodeTransform | undefined;
  setTransform(value?: ASTNodeTransform): void;

  hasAttachobject(): boolean;
  clearAttachobject(): void;
  getAttachobject(): ASTNodeAttachObject | undefined;
  setAttachobject(value?: ASTNodeAttachObject): void;

  hasTransferobject(): boolean;
  clearTransferobject(): void;
  getTransferobject(): ASTNodeTransferObject | undefined;
  setTransferobject(value?: ASTNodeTransferObject): void;

  hasFingerprint(): boolean;
  clearFingerprint(): void;
  getFingerprint(): ASTNodeFingerprint | undefined;
  setFingerprint(value?: ASTNodeFingerprint): void;

  hasBooleannot(): boolean;
  clearBooleannot(): void;
  getBooleannot(): ASTNodeBooleanNot | undefined;
  setBooleannot(value?: ASTNodeBooleanNot): void;

  hasBooleanbinary(): boolean;
  clearBooleanbinary(): void;
  getBooleanbinary(): ASTNodeBooleanBinary | undefined;
  setBooleanbinary(value?: ASTNodeBooleanBinary): void;

  hasCondition(): boolean;
  clearCondition(): void;
  getCondition(): ASTNodeCondition | undefined;
  setCondition(value?: ASTNodeCondition): void;

  hasForeach(): boolean;
  clearForeach(): void;
  getForeach(): ASTNodeForEach | undefined;
  setForeach(value?: ASTNodeForEach): void;

  hasEq(): boolean;
  clearEq(): void;
  getEq(): ASTNodeEq | undefined;
  setEq(value?: ASTNodeEq): void;

  hasLt(): boolean;
  clearLt(): void;
  getLt(): ASTNodeLt | undefined;
  setLt(value?: ASTNodeLt): void;

  hasLte(): boolean;
  clearLte(): void;
  getLte(): ASTNodeLte | undefined;
  setLte(value?: ASTNodeLte): void;

  hasGt(): boolean;
  clearGt(): void;
  getGt(): ASTNodeGt | undefined;
  setGt(value?: ASTNodeGt): void;

  hasGte(): boolean;
  clearGte(): void;
  getGte(): ASTNodeGte | undefined;
  setGte(value?: ASTNodeGte): void;

  hasMathscalar(): boolean;
  clearMathscalar(): void;
  getMathscalar(): ASTNodeMathScalar | undefined;
  setMathscalar(value?: ASTNodeMathScalar): void;

  getOpcodeCase(): ASTNode.OpcodeCase;
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ASTNode.AsObject;
  static toObject(includeInstance: boolean, msg: ASTNode): ASTNode.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ASTNode, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ASTNode;
  static deserializeBinaryFromReader(message: ASTNode, reader: jspb.BinaryReader): ASTNode;
}

export namespace ASTNode {
  export type AsObject = {
    defaultvalue?: Value.AsObject,
    getprop?: ASTNodeGetProp.AsObject,
    setprop?: ASTNodeSetProp.AsObject,
    getcontext?: ASTNodeGetContext.AsObject,
    setcontext?: ASTNodeSetContext.AsObject,
    protectedprop?: ASTNodeProtectedProp.AsObject,
    sendmessage?: ASTNodeSendMessage.AsObject,
    sendevent?: ASTNodeSendEvent.AsObject,
    send?: ASTNodeSend.AsObject,
    createobject?: ASTNodeCreateObject.AsObject,
    transform?: ASTNodeTransform.AsObject,
    attachobject?: ASTNodeAttachObject.AsObject,
    transferobject?: ASTNodeTransferObject.AsObject,
    fingerprint?: ASTNodeFingerprint.AsObject,
    booleannot?: ASTNodeBooleanNot.AsObject,
    booleanbinary?: ASTNodeBooleanBinary.AsObject,
    condition?: ASTNodeCondition.AsObject,
    foreach?: ASTNodeForEach.AsObject,
    eq?: ASTNodeEq.AsObject,
    lt?: ASTNodeLt.AsObject,
    lte?: ASTNodeLte.AsObject,
    gt?: ASTNodeGt.AsObject,
    gte?: ASTNodeGte.AsObject,
    mathscalar?: ASTNodeMathScalar.AsObject,
  }

  export enum OpcodeCase {
    OPCODE_NOT_SET = 0,
    GETPROP = 2,
    SETPROP = 3,
    GETCONTEXT = 4,
    SETCONTEXT = 5,
    PROTECTEDPROP = 6,
    SENDMESSAGE = 7,
    SENDEVENT = 8,
    SEND = 9,
    CREATEOBJECT = 10,
    TRANSFORM = 11,
    ATTACHOBJECT = 12,
    TRANSFEROBJECT = 13,
    FINGERPRINT = 14,
    BOOLEANNOT = 15,
    BOOLEANBINARY = 16,
    CONDITION = 17,
    FOREACH = 18,
    EQ = 19,
    LT = 20,
    LTE = 21,
    GT = 22,
    GTE = 23,
    MATHSCALAR = 24,
  }
}

export class ASTNodeGetProp extends jspb.Message {
  hasRef(): boolean;
  clearRef(): void;
  getRef(): Value | undefined;
  setRef(value?: Value): void;

  clearPathList(): void;
  getPathList(): Array<Value>;
  setPathList(value: Array<Value>): void;
  addPath(value?: Value, index?: number): Value;

  hasDefaultvalue(): boolean;
  clearDefaultvalue(): void;
  getDefaultvalue(): Value | undefined;
  setDefaultvalue(value?: Value): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ASTNodeGetProp.AsObject;
  static toObject(includeInstance: boolean, msg: ASTNodeGetProp): ASTNodeGetProp.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ASTNodeGetProp, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ASTNodeGetProp;
  static deserializeBinaryFromReader(message: ASTNodeGetProp, reader: jspb.BinaryReader): ASTNodeGetProp;
}

export namespace ASTNodeGetProp {
  export type AsObject = {
    ref?: Value.AsObject,
    pathList: Array<Value.AsObject>,
    defaultvalue?: Value.AsObject,
  }
}

export class ASTNodeSetProp extends jspb.Message {
  clearPathList(): void;
  getPathList(): Array<Value>;
  setPathList(value: Array<Value>): void;
  addPath(value?: Value, index?: number): Value;

  hasValue(): boolean;
  clearValue(): void;
  getValue(): Value | undefined;
  setValue(value?: Value): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ASTNodeSetProp.AsObject;
  static toObject(includeInstance: boolean, msg: ASTNodeSetProp): ASTNodeSetProp.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ASTNodeSetProp, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ASTNodeSetProp;
  static deserializeBinaryFromReader(message: ASTNodeSetProp, reader: jspb.BinaryReader): ASTNodeSetProp;
}

export namespace ASTNodeSetProp {
  export type AsObject = {
    pathList: Array<Value.AsObject>,
    value?: Value.AsObject,
  }
}

export class ASTNodeGetContext extends jspb.Message {
  clearPathList(): void;
  getPathList(): Array<Value>;
  setPathList(value: Array<Value>): void;
  addPath(value?: Value, index?: number): Value;

  hasDefaultvalue(): boolean;
  clearDefaultvalue(): void;
  getDefaultvalue(): Value | undefined;
  setDefaultvalue(value?: Value): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ASTNodeGetContext.AsObject;
  static toObject(includeInstance: boolean, msg: ASTNodeGetContext): ASTNodeGetContext.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ASTNodeGetContext, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ASTNodeGetContext;
  static deserializeBinaryFromReader(message: ASTNodeGetContext, reader: jspb.BinaryReader): ASTNodeGetContext;
}

export namespace ASTNodeGetContext {
  export type AsObject = {
    pathList: Array<Value.AsObject>,
    defaultvalue?: Value.AsObject,
  }
}

export class ASTNodeSetContext extends jspb.Message {
  clearPathList(): void;
  getPathList(): Array<Value>;
  setPathList(value: Array<Value>): void;
  addPath(value?: Value, index?: number): Value;

  hasValue(): boolean;
  clearValue(): void;
  getValue(): Value | undefined;
  setValue(value?: Value): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ASTNodeSetContext.AsObject;
  static toObject(includeInstance: boolean, msg: ASTNodeSetContext): ASTNodeSetContext.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ASTNodeSetContext, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ASTNodeSetContext;
  static deserializeBinaryFromReader(message: ASTNodeSetContext, reader: jspb.BinaryReader): ASTNodeSetContext;
}

export namespace ASTNodeSetContext {
  export type AsObject = {
    pathList: Array<Value.AsObject>,
    value?: Value.AsObject,
  }
}

export class ASTNodeProtectedProp extends jspb.Message {
  getName(): ASTNodeProtectedProp.NameMap[keyof ASTNodeProtectedProp.NameMap];
  setName(value: ASTNodeProtectedProp.NameMap[keyof ASTNodeProtectedProp.NameMap]): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ASTNodeProtectedProp.AsObject;
  static toObject(includeInstance: boolean, msg: ASTNodeProtectedProp): ASTNodeProtectedProp.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ASTNodeProtectedProp, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ASTNodeProtectedProp;
  static deserializeBinaryFromReader(message: ASTNodeProtectedProp, reader: jspb.BinaryReader): ASTNodeProtectedProp;
}

export namespace ASTNodeProtectedProp {
  export type AsObject = {
    name: ASTNodeProtectedProp.NameMap[keyof ASTNodeProtectedProp.NameMap],
  }

  export interface NameMap {
    BALANCE: 0;
    SENDER: 1;
    CALLER: 2;
    PARENT: 3;
  }

  export const Name: NameMap;
}

export class ASTNodeSendMessage extends jspb.Message {
  getTarget(): Uint8Array | string;
  getTarget_asU8(): Uint8Array;
  getTarget_asB64(): string;
  setTarget(value: Uint8Array | string): void;

  getHandler(): string;
  setHandler(value: string): void;

  getGaslimit(): Uint8Array | string;
  getGaslimit_asU8(): Uint8Array;
  getGaslimit_asB64(): string;
  setGaslimit(value: Uint8Array | string): void;

  hasContext(): boolean;
  clearContext(): void;
  getContext(): PropMap | undefined;
  setContext(value?: PropMap): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ASTNodeSendMessage.AsObject;
  static toObject(includeInstance: boolean, msg: ASTNodeSendMessage): ASTNodeSendMessage.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ASTNodeSendMessage, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ASTNodeSendMessage;
  static deserializeBinaryFromReader(message: ASTNodeSendMessage, reader: jspb.BinaryReader): ASTNodeSendMessage;
}

export namespace ASTNodeSendMessage {
  export type AsObject = {
    target: Uint8Array | string,
    handler: string,
    gaslimit: Uint8Array | string,
    context?: PropMap.AsObject,
  }
}

export class ASTNodeSendEvent extends jspb.Message {
  getObjectdigestuid(): Uint8Array | string;
  getObjectdigestuid_asU8(): Uint8Array;
  getObjectdigestuid_asB64(): string;
  setObjectdigestuid(value: Uint8Array | string): void;

  hasContext(): boolean;
  clearContext(): void;
  getContext(): PropMap | undefined;
  setContext(value?: PropMap): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ASTNodeSendEvent.AsObject;
  static toObject(includeInstance: boolean, msg: ASTNodeSendEvent): ASTNodeSendEvent.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ASTNodeSendEvent, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ASTNodeSendEvent;
  static deserializeBinaryFromReader(message: ASTNodeSendEvent, reader: jspb.BinaryReader): ASTNodeSendEvent;
}

export namespace ASTNodeSendEvent {
  export type AsObject = {
    objectdigestuid: Uint8Array | string,
    context?: PropMap.AsObject,
  }
}

export class ASTNodeSend extends jspb.Message {
  getTo(): Uint8Array | string;
  getTo_asU8(): Uint8Array;
  getTo_asB64(): string;
  setTo(value: Uint8Array | string): void;

  getAmount(): Uint8Array | string;
  getAmount_asU8(): Uint8Array;
  getAmount_asB64(): string;
  setAmount(value: Uint8Array | string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ASTNodeSend.AsObject;
  static toObject(includeInstance: boolean, msg: ASTNodeSend): ASTNodeSend.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ASTNodeSend, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ASTNodeSend;
  static deserializeBinaryFromReader(message: ASTNodeSend, reader: jspb.BinaryReader): ASTNodeSend;
}

export namespace ASTNodeSend {
  export type AsObject = {
    to: Uint8Array | string,
    amount: Uint8Array | string,
  }
}

export class ASTNodeCreateObject extends jspb.Message {
  getPrototype(): Uint8Array | string;
  getPrototype_asU8(): Uint8Array;
  getPrototype_asB64(): string;
  setPrototype(value: Uint8Array | string): void;

  hasProperties(): boolean;
  clearProperties(): void;
  getProperties(): PropMap | undefined;
  setProperties(value?: PropMap): void;

  getPayment(): Uint8Array | string;
  getPayment_asU8(): Uint8Array;
  getPayment_asB64(): string;
  setPayment(value: Uint8Array | string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ASTNodeCreateObject.AsObject;
  static toObject(includeInstance: boolean, msg: ASTNodeCreateObject): ASTNodeCreateObject.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ASTNodeCreateObject, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ASTNodeCreateObject;
  static deserializeBinaryFromReader(message: ASTNodeCreateObject, reader: jspb.BinaryReader): ASTNodeCreateObject;
}

export namespace ASTNodeCreateObject {
  export type AsObject = {
    prototype: Uint8Array | string,
    properties?: PropMap.AsObject,
    payment: Uint8Array | string,
  }
}

export class ASTNodeTransform extends jspb.Message {
  hasTransformation(): boolean;
  clearTransformation(): void;
  getTransformation(): Value | undefined;
  setTransformation(value?: Value): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ASTNodeTransform.AsObject;
  static toObject(includeInstance: boolean, msg: ASTNodeTransform): ASTNodeTransform.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ASTNodeTransform, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ASTNodeTransform;
  static deserializeBinaryFromReader(message: ASTNodeTransform, reader: jspb.BinaryReader): ASTNodeTransform;
}

export namespace ASTNodeTransform {
  export type AsObject = {
    transformation?: Value.AsObject,
  }
}

export class ASTNodeAttachObject extends jspb.Message {
  getUid(): Uint8Array | string;
  getUid_asU8(): Uint8Array;
  getUid_asB64(): string;
  setUid(value: Uint8Array | string): void;

  getPrototypeuid(): Uint8Array | string;
  getPrototypeuid_asU8(): Uint8Array;
  getPrototypeuid_asB64(): string;
  setPrototypeuid(value: Uint8Array | string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ASTNodeAttachObject.AsObject;
  static toObject(includeInstance: boolean, msg: ASTNodeAttachObject): ASTNodeAttachObject.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ASTNodeAttachObject, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ASTNodeAttachObject;
  static deserializeBinaryFromReader(message: ASTNodeAttachObject, reader: jspb.BinaryReader): ASTNodeAttachObject;
}

export namespace ASTNodeAttachObject {
  export type AsObject = {
    uid: Uint8Array | string,
    prototypeuid: Uint8Array | string,
  }
}

export class ASTNodeTransferObject extends jspb.Message {
  getFrom(): Uint8Array | string;
  getFrom_asU8(): Uint8Array;
  getFrom_asB64(): string;
  setFrom(value: Uint8Array | string): void;

  getTo(): Uint8Array | string;
  getTo_asU8(): Uint8Array;
  getTo_asB64(): string;
  setTo(value: Uint8Array | string): void;

  getPrice(): Uint8Array | string;
  getPrice_asU8(): Uint8Array;
  getPrice_asB64(): string;
  setPrice(value: Uint8Array | string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ASTNodeTransferObject.AsObject;
  static toObject(includeInstance: boolean, msg: ASTNodeTransferObject): ASTNodeTransferObject.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ASTNodeTransferObject, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ASTNodeTransferObject;
  static deserializeBinaryFromReader(message: ASTNodeTransferObject, reader: jspb.BinaryReader): ASTNodeTransferObject;
}

export namespace ASTNodeTransferObject {
  export type AsObject = {
    from: Uint8Array | string,
    to: Uint8Array | string,
    price: Uint8Array | string,
  }
}

export class ASTNodeFingerprint extends jspb.Message {
  hasUid(): boolean;
  clearUid(): void;
  getUid(): Uint8Array | string;
  getUid_asU8(): Uint8Array;
  getUid_asB64(): string;
  setUid(value: Uint8Array | string): void;

  hasCid(): boolean;
  clearCid(): void;
  getCid(): Uint8Array | string;
  getCid_asU8(): Uint8Array;
  getCid_asB64(): string;
  setCid(value: Uint8Array | string): void;

  clearPropertiesList(): void;
  getPropertiesList(): Array<string>;
  setPropertiesList(value: Array<string>): void;
  addProperties(value: string, index?: number): string;

  getObjectCase(): ASTNodeFingerprint.ObjectCase;
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ASTNodeFingerprint.AsObject;
  static toObject(includeInstance: boolean, msg: ASTNodeFingerprint): ASTNodeFingerprint.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ASTNodeFingerprint, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ASTNodeFingerprint;
  static deserializeBinaryFromReader(message: ASTNodeFingerprint, reader: jspb.BinaryReader): ASTNodeFingerprint;
}

export namespace ASTNodeFingerprint {
  export type AsObject = {
    uid: Uint8Array | string,
    cid: Uint8Array | string,
    propertiesList: Array<string>,
  }

  export enum ObjectCase {
    OBJECT_NOT_SET = 0,
    UID = 1,
    CID = 2,
  }
}

export class ASTNodeBooleanNot extends jspb.Message {
  hasLogic(): boolean;
  clearLogic(): void;
  getLogic(): Value | undefined;
  setLogic(value?: Value): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ASTNodeBooleanNot.AsObject;
  static toObject(includeInstance: boolean, msg: ASTNodeBooleanNot): ASTNodeBooleanNot.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ASTNodeBooleanNot, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ASTNodeBooleanNot;
  static deserializeBinaryFromReader(message: ASTNodeBooleanNot, reader: jspb.BinaryReader): ASTNodeBooleanNot;
}

export namespace ASTNodeBooleanNot {
  export type AsObject = {
    logic?: Value.AsObject,
  }
}

export class ASTNodeBooleanBinary extends jspb.Message {
  hasLogic1(): boolean;
  clearLogic1(): void;
  getLogic1(): Value | undefined;
  setLogic1(value?: Value): void;

  hasLogic2(): boolean;
  clearLogic2(): void;
  getLogic2(): Value | undefined;
  setLogic2(value?: Value): void;

  getOp(): ASTNodeBooleanBinary.OpMap[keyof ASTNodeBooleanBinary.OpMap];
  setOp(value: ASTNodeBooleanBinary.OpMap[keyof ASTNodeBooleanBinary.OpMap]): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ASTNodeBooleanBinary.AsObject;
  static toObject(includeInstance: boolean, msg: ASTNodeBooleanBinary): ASTNodeBooleanBinary.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ASTNodeBooleanBinary, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ASTNodeBooleanBinary;
  static deserializeBinaryFromReader(message: ASTNodeBooleanBinary, reader: jspb.BinaryReader): ASTNodeBooleanBinary;
}

export namespace ASTNodeBooleanBinary {
  export type AsObject = {
    logic1?: Value.AsObject,
    logic2?: Value.AsObject,
    op: ASTNodeBooleanBinary.OpMap[keyof ASTNodeBooleanBinary.OpMap],
  }

  export interface OpMap {
    OR: 0;
    AND: 1;
    XOR: 2;
  }

  export const Op: OpMap;
}

export class ASTNodeCondition extends jspb.Message {
  hasCondition(): boolean;
  clearCondition(): void;
  getCondition(): Value | undefined;
  setCondition(value?: Value): void;

  hasThen(): boolean;
  clearThen(): void;
  getThen(): Value | undefined;
  setThen(value?: Value): void;

  hasElse(): boolean;
  clearElse(): void;
  getElse(): Value | undefined;
  setElse(value?: Value): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ASTNodeCondition.AsObject;
  static toObject(includeInstance: boolean, msg: ASTNodeCondition): ASTNodeCondition.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ASTNodeCondition, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ASTNodeCondition;
  static deserializeBinaryFromReader(message: ASTNodeCondition, reader: jspb.BinaryReader): ASTNodeCondition;
}

export namespace ASTNodeCondition {
  export type AsObject = {
    condition?: Value.AsObject,
    then?: Value.AsObject,
    pb_else?: Value.AsObject,
  }
}

export class ASTNodeForEach extends jspb.Message {
  hasList(): boolean;
  clearList(): void;
  getList(): Value | undefined;
  setList(value?: Value): void;

  hasDo(): boolean;
  clearDo(): void;
  getDo(): Value | undefined;
  setDo(value?: Value): void;

  hasAccumulate(): boolean;
  clearAccumulate(): void;
  getAccumulate(): Value | undefined;
  setAccumulate(value?: Value): void;

  hasCondition(): boolean;
  clearCondition(): void;
  getCondition(): Value | undefined;
  setCondition(value?: Value): void;

  getActionCase(): ASTNodeForEach.ActionCase;
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ASTNodeForEach.AsObject;
  static toObject(includeInstance: boolean, msg: ASTNodeForEach): ASTNodeForEach.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ASTNodeForEach, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ASTNodeForEach;
  static deserializeBinaryFromReader(message: ASTNodeForEach, reader: jspb.BinaryReader): ASTNodeForEach;
}

export namespace ASTNodeForEach {
  export type AsObject = {
    list?: Value.AsObject,
    pb_do?: Value.AsObject,
    accumulate?: Value.AsObject,
    condition?: Value.AsObject,
  }

  export enum ActionCase {
    ACTION_NOT_SET = 0,
    DO = 2,
    ACCUMULATE = 3,
  }
}

export class ASTNodeEq extends jspb.Message {
  hasValue1(): boolean;
  clearValue1(): void;
  getValue1(): Value | undefined;
  setValue1(value?: Value): void;

  hasValue2(): boolean;
  clearValue2(): void;
  getValue2(): Value | undefined;
  setValue2(value?: Value): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ASTNodeEq.AsObject;
  static toObject(includeInstance: boolean, msg: ASTNodeEq): ASTNodeEq.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ASTNodeEq, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ASTNodeEq;
  static deserializeBinaryFromReader(message: ASTNodeEq, reader: jspb.BinaryReader): ASTNodeEq;
}

export namespace ASTNodeEq {
  export type AsObject = {
    value1?: Value.AsObject,
    value2?: Value.AsObject,
  }
}

export class ASTNodeLt extends jspb.Message {
  hasValue1(): boolean;
  clearValue1(): void;
  getValue1(): Value | undefined;
  setValue1(value?: Value): void;

  hasValue2(): boolean;
  clearValue2(): void;
  getValue2(): Value | undefined;
  setValue2(value?: Value): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ASTNodeLt.AsObject;
  static toObject(includeInstance: boolean, msg: ASTNodeLt): ASTNodeLt.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ASTNodeLt, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ASTNodeLt;
  static deserializeBinaryFromReader(message: ASTNodeLt, reader: jspb.BinaryReader): ASTNodeLt;
}

export namespace ASTNodeLt {
  export type AsObject = {
    value1?: Value.AsObject,
    value2?: Value.AsObject,
  }
}

export class ASTNodeLte extends jspb.Message {
  hasValue1(): boolean;
  clearValue1(): void;
  getValue1(): Value | undefined;
  setValue1(value?: Value): void;

  hasValue2(): boolean;
  clearValue2(): void;
  getValue2(): Value | undefined;
  setValue2(value?: Value): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ASTNodeLte.AsObject;
  static toObject(includeInstance: boolean, msg: ASTNodeLte): ASTNodeLte.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ASTNodeLte, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ASTNodeLte;
  static deserializeBinaryFromReader(message: ASTNodeLte, reader: jspb.BinaryReader): ASTNodeLte;
}

export namespace ASTNodeLte {
  export type AsObject = {
    value1?: Value.AsObject,
    value2?: Value.AsObject,
  }
}

export class ASTNodeGte extends jspb.Message {
  hasValue1(): boolean;
  clearValue1(): void;
  getValue1(): Value | undefined;
  setValue1(value?: Value): void;

  hasValue2(): boolean;
  clearValue2(): void;
  getValue2(): Value | undefined;
  setValue2(value?: Value): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ASTNodeGte.AsObject;
  static toObject(includeInstance: boolean, msg: ASTNodeGte): ASTNodeGte.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ASTNodeGte, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ASTNodeGte;
  static deserializeBinaryFromReader(message: ASTNodeGte, reader: jspb.BinaryReader): ASTNodeGte;
}

export namespace ASTNodeGte {
  export type AsObject = {
    value1?: Value.AsObject,
    value2?: Value.AsObject,
  }
}

export class ASTNodeGt extends jspb.Message {
  hasValue1(): boolean;
  clearValue1(): void;
  getValue1(): Value | undefined;
  setValue1(value?: Value): void;

  hasValue2(): boolean;
  clearValue2(): void;
  getValue2(): Value | undefined;
  setValue2(value?: Value): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ASTNodeGt.AsObject;
  static toObject(includeInstance: boolean, msg: ASTNodeGt): ASTNodeGt.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ASTNodeGt, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ASTNodeGt;
  static deserializeBinaryFromReader(message: ASTNodeGt, reader: jspb.BinaryReader): ASTNodeGt;
}

export namespace ASTNodeGt {
  export type AsObject = {
    value1?: Value.AsObject,
    value2?: Value.AsObject,
  }
}

export class ASTNodeMathScalar extends jspb.Message {
  clearValuesList(): void;
  getValuesList(): Array<Value>;
  setValuesList(value: Array<Value>): void;
  addValues(value?: Value, index?: number): Value;

  getOp(): ASTNodeMathScalar.OpMap[keyof ASTNodeMathScalar.OpMap];
  setOp(value: ASTNodeMathScalar.OpMap[keyof ASTNodeMathScalar.OpMap]): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ASTNodeMathScalar.AsObject;
  static toObject(includeInstance: boolean, msg: ASTNodeMathScalar): ASTNodeMathScalar.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ASTNodeMathScalar, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ASTNodeMathScalar;
  static deserializeBinaryFromReader(message: ASTNodeMathScalar, reader: jspb.BinaryReader): ASTNodeMathScalar;
}

export namespace ASTNodeMathScalar {
  export type AsObject = {
    valuesList: Array<Value.AsObject>,
    op: ASTNodeMathScalar.OpMap[keyof ASTNodeMathScalar.OpMap],
  }

  export interface OpMap {
    NEG: 0;
    ADD: 1;
    SUB: 2;
    MUL: 3;
    DIV: 4;
    MOD: 6;
    POW: 7;
  }

  export const Op: OpMap;
}

