// package: mediaProcess
// file: avvyprotocol/mediaProcess.proto

import * as jspb from "google-protobuf";
import * as avvyprotocol_base_pb from "../avvyprotocol/base_pb";

export class MediaProcessRequest extends jspb.Message {
  hasData(): boolean;
  clearData(): void;
  getData(): avvyprotocol_base_pb.Data | undefined;
  setData(value?: avvyprotocol_base_pb.Data): void;

  getFileext(): string;
  setFileext(value: string): void;

  getText(): string;
  setText(value: string): void;

  hasParameters(): boolean;
  clearParameters(): void;
  getParameters(): Parameters | undefined;
  setParameters(value?: Parameters): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): MediaProcessRequest.AsObject;
  static toObject(includeInstance: boolean, msg: MediaProcessRequest): MediaProcessRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: MediaProcessRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): MediaProcessRequest;
  static deserializeBinaryFromReader(message: MediaProcessRequest, reader: jspb.BinaryReader): MediaProcessRequest;
}

export namespace MediaProcessRequest {
  export type AsObject = {
    data?: avvyprotocol_base_pb.Data.AsObject,
    fileext: string,
    text: string,
    parameters?: Parameters.AsObject,
  }
}

export class MediaProcessResponse extends jspb.Message {
  hasData(): boolean;
  clearData(): void;
  getData(): avvyprotocol_base_pb.Data | undefined;
  setData(value?: avvyprotocol_base_pb.Data): void;

  hasThumbnail(): boolean;
  clearThumbnail(): void;
  getThumbnail(): avvyprotocol_base_pb.Data | undefined;
  setThumbnail(value?: avvyprotocol_base_pb.Data): void;

  getFileext(): string;
  setFileext(value: string): void;

  getError(): string;
  setError(value: string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): MediaProcessResponse.AsObject;
  static toObject(includeInstance: boolean, msg: MediaProcessResponse): MediaProcessResponse.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: MediaProcessResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): MediaProcessResponse;
  static deserializeBinaryFromReader(message: MediaProcessResponse, reader: jspb.BinaryReader): MediaProcessResponse;
}

export namespace MediaProcessResponse {
  export type AsObject = {
    data?: avvyprotocol_base_pb.Data.AsObject,
    thumbnail?: avvyprotocol_base_pb.Data.AsObject,
    fileext: string,
    error: string,
  }
}

export class VideoParameters extends jspb.Message {
  getWidth(): number;
  setWidth(value: number): void;

  getHeight(): number;
  setHeight(value: number): void;

  getLength(): number;
  setLength(value: number): void;

  getScaling(): string;
  setScaling(value: string): void;

  getExt(): string;
  setExt(value: string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): VideoParameters.AsObject;
  static toObject(includeInstance: boolean, msg: VideoParameters): VideoParameters.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: VideoParameters, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): VideoParameters;
  static deserializeBinaryFromReader(message: VideoParameters, reader: jspb.BinaryReader): VideoParameters;
}

export namespace VideoParameters {
  export type AsObject = {
    width: number,
    height: number,
    length: number,
    scaling: string,
    ext: string,
  }
}

export class ImageParameters extends jspb.Message {
  getWidth(): number;
  setWidth(value: number): void;

  getHeight(): number;
  setHeight(value: number): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ImageParameters.AsObject;
  static toObject(includeInstance: boolean, msg: ImageParameters): ImageParameters.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ImageParameters, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ImageParameters;
  static deserializeBinaryFromReader(message: ImageParameters, reader: jspb.BinaryReader): ImageParameters;
}

export namespace ImageParameters {
  export type AsObject = {
    width: number,
    height: number,
  }
}

export class Parameters extends jspb.Message {
  hasVideoparams(): boolean;
  clearVideoparams(): void;
  getVideoparams(): VideoParameters | undefined;
  setVideoparams(value?: VideoParameters): void;

  hasImageparams(): boolean;
  clearImageparams(): void;
  getImageparams(): ImageParameters | undefined;
  setImageparams(value?: ImageParameters): void;

  getValueCase(): Parameters.ValueCase;
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): Parameters.AsObject;
  static toObject(includeInstance: boolean, msg: Parameters): Parameters.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: Parameters, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): Parameters;
  static deserializeBinaryFromReader(message: Parameters, reader: jspb.BinaryReader): Parameters;
}

export namespace Parameters {
  export type AsObject = {
    videoparams?: VideoParameters.AsObject,
    imageparams?: ImageParameters.AsObject,
  }

  export enum ValueCase {
    VALUE_NOT_SET = 0,
    VIDEOPARAMS = 1,
    IMAGEPARAMS = 2,
  }
}

