// package: mediaProcess
// file: avvyprotocol/mediaProcess.proto

import * as avvyprotocol_mediaProcess_pb from "../avvyprotocol/mediaProcess_pb";
import {grpc} from "@improbable-eng/grpc-web";

type MediaProcessProcess = {
  readonly methodName: string;
  readonly service: typeof MediaProcess;
  readonly requestStream: false;
  readonly responseStream: false;
  readonly requestType: typeof avvyprotocol_mediaProcess_pb.MediaProcessRequest;
  readonly responseType: typeof avvyprotocol_mediaProcess_pb.MediaProcessResponse;
};

export class MediaProcess {
  static readonly serviceName: string;
  static readonly Process: MediaProcessProcess;
}

export type ServiceError = { message: string, code: number; metadata: grpc.Metadata }
export type Status = { details: string, code: number; metadata: grpc.Metadata }

interface UnaryResponse {
  cancel(): void;
}
interface ResponseStream<T> {
  cancel(): void;
  on(type: 'data', handler: (message: T) => void): ResponseStream<T>;
  on(type: 'end', handler: (status?: Status) => void): ResponseStream<T>;
  on(type: 'status', handler: (status: Status) => void): ResponseStream<T>;
}
interface RequestStream<T> {
  write(message: T): RequestStream<T>;
  end(): void;
  cancel(): void;
  on(type: 'end', handler: (status?: Status) => void): RequestStream<T>;
  on(type: 'status', handler: (status: Status) => void): RequestStream<T>;
}
interface BidirectionalStream<ReqT, ResT> {
  write(message: ReqT): BidirectionalStream<ReqT, ResT>;
  end(): void;
  cancel(): void;
  on(type: 'data', handler: (message: ResT) => void): BidirectionalStream<ReqT, ResT>;
  on(type: 'end', handler: (status?: Status) => void): BidirectionalStream<ReqT, ResT>;
  on(type: 'status', handler: (status: Status) => void): BidirectionalStream<ReqT, ResT>;
}

export class MediaProcessClient {
  readonly serviceHost: string;

  constructor(serviceHost: string, options?: grpc.RpcOptions);
  process(
    requestMessage: avvyprotocol_mediaProcess_pb.MediaProcessRequest,
    metadata: grpc.Metadata,
    callback: (error: ServiceError|null, responseMessage: avvyprotocol_mediaProcess_pb.MediaProcessResponse|null) => void
  ): UnaryResponse;
  process(
    requestMessage: avvyprotocol_mediaProcess_pb.MediaProcessRequest,
    callback: (error: ServiceError|null, responseMessage: avvyprotocol_mediaProcess_pb.MediaProcessResponse|null) => void
  ): UnaryResponse;
}

