// package: mediaProcess
// file: avvyprotocol/mediaProcess.proto

var avvyprotocol_mediaProcess_pb = require("../avvyprotocol/mediaProcess_pb");
var grpc = require("@improbable-eng/grpc-web").grpc;

var MediaProcess = (function () {
  function MediaProcess() {}
  MediaProcess.serviceName = "mediaProcess.MediaProcess";
  return MediaProcess;
}());

MediaProcess.Process = {
  methodName: "Process",
  service: MediaProcess,
  requestStream: false,
  responseStream: false,
  requestType: avvyprotocol_mediaProcess_pb.MediaProcessRequest,
  responseType: avvyprotocol_mediaProcess_pb.MediaProcessResponse
};

exports.MediaProcess = MediaProcess;

function MediaProcessClient(serviceHost, options) {
  this.serviceHost = serviceHost;
  this.options = options || {};
}

MediaProcessClient.prototype.process = function process(requestMessage, metadata, callback) {
  if (arguments.length === 2) {
    callback = arguments[1];
  }
  var client = grpc.unary(MediaProcess.Process, {
    request: requestMessage,
    host: this.serviceHost,
    metadata: metadata,
    transport: this.options.transport,
    debug: this.options.debug,
    onEnd: function (response) {
      if (callback) {
        if (response.status !== grpc.Code.OK) {
          var err = new Error(response.statusMessage);
          err.code = response.status;
          err.metadata = response.trailers;
          callback(err, null);
        } else {
          callback(null, response.message);
        }
      }
    }
  });
  return {
    cancel: function () {
      callback = null;
      client.close();
    }
  };
};

exports.MediaProcessClient = MediaProcessClient;

