// package: relayer
// file: avvyprotocol/relayer.proto

import * as jspb from "google-protobuf";
import * as avvyprotocol_workers_pb from "../avvyprotocol/workers_pb";
import * as avvyprotocol_base_pb from "../avvyprotocol/base_pb";

export class ProcessParameters extends jspb.Message {
  hasRequest(): boolean;
  clearRequest(): void;
  getRequest(): avvyprotocol_workers_pb.WorkerRequest | undefined;
  setRequest(value?: avvyprotocol_workers_pb.WorkerRequest): void;

  getStoreresult(): boolean;
  setStoreresult(value: boolean): void;

  hasTags(): boolean;
  clearTags(): void;
  getTags(): avvyprotocol_base_pb.Tags | undefined;
  setTags(value?: avvyprotocol_base_pb.Tags): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ProcessParameters.AsObject;
  static toObject(includeInstance: boolean, msg: ProcessParameters): ProcessParameters.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ProcessParameters, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ProcessParameters;
  static deserializeBinaryFromReader(message: ProcessParameters, reader: jspb.BinaryReader): ProcessParameters;
}

export namespace ProcessParameters {
  export type AsObject = {
    request?: avvyprotocol_workers_pb.WorkerRequest.AsObject,
    storeresult: boolean,
    tags?: avvyprotocol_base_pb.Tags.AsObject,
  }
}

export class Stored extends jspb.Message {
  clearCidsList(): void;
  getCidsList(): Array<avvyprotocol_base_pb.Cid>;
  setCidsList(value: Array<avvyprotocol_base_pb.Cid>): void;
  addCids(value?: avvyprotocol_base_pb.Cid, index?: number): avvyprotocol_base_pb.Cid;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): Stored.AsObject;
  static toObject(includeInstance: boolean, msg: Stored): Stored.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: Stored, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): Stored;
  static deserializeBinaryFromReader(message: Stored, reader: jspb.BinaryReader): Stored;
}

export namespace Stored {
  export type AsObject = {
    cidsList: Array<avvyprotocol_base_pb.Cid.AsObject>,
  }
}

export class ProcessResult extends jspb.Message {
  hasResponse(): boolean;
  clearResponse(): void;
  getResponse(): avvyprotocol_workers_pb.WorkerResponse | undefined;
  setResponse(value?: avvyprotocol_workers_pb.WorkerResponse): void;

  hasStored(): boolean;
  clearStored(): void;
  getStored(): Stored | undefined;
  setStored(value?: Stored): void;

  hasError(): boolean;
  clearError(): void;
  getError(): string;
  setError(value: string): void;

  getResultCase(): ProcessResult.ResultCase;
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ProcessResult.AsObject;
  static toObject(includeInstance: boolean, msg: ProcessResult): ProcessResult.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ProcessResult, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ProcessResult;
  static deserializeBinaryFromReader(message: ProcessResult, reader: jspb.BinaryReader): ProcessResult;
}

export namespace ProcessResult {
  export type AsObject = {
    response?: avvyprotocol_workers_pb.WorkerResponse.AsObject,
    stored?: Stored.AsObject,
    error: string,
  }

  export enum ResultCase {
    RESULT_NOT_SET = 0,
    RESPONSE = 1,
    STORED = 2,
    ERROR = 3,
  }
}

export class AddParameters extends jspb.Message {
  hasData(): boolean;
  clearData(): void;
  getData(): avvyprotocol_base_pb.Data | undefined;
  setData(value?: avvyprotocol_base_pb.Data): void;

  hasTags(): boolean;
  clearTags(): void;
  getTags(): avvyprotocol_base_pb.Tags | undefined;
  setTags(value?: avvyprotocol_base_pb.Tags): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): AddParameters.AsObject;
  static toObject(includeInstance: boolean, msg: AddParameters): AddParameters.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: AddParameters, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): AddParameters;
  static deserializeBinaryFromReader(message: AddParameters, reader: jspb.BinaryReader): AddParameters;
}

export namespace AddParameters {
  export type AsObject = {
    data?: avvyprotocol_base_pb.Data.AsObject,
    tags?: avvyprotocol_base_pb.Tags.AsObject,
  }
}

export class AddResult extends jspb.Message {
  clearCidsList(): void;
  getCidsList(): Array<avvyprotocol_base_pb.Cid>;
  setCidsList(value: Array<avvyprotocol_base_pb.Cid>): void;
  addCids(value?: avvyprotocol_base_pb.Cid, index?: number): avvyprotocol_base_pb.Cid;

  getError(): string;
  setError(value: string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): AddResult.AsObject;
  static toObject(includeInstance: boolean, msg: AddResult): AddResult.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: AddResult, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): AddResult;
  static deserializeBinaryFromReader(message: AddResult, reader: jspb.BinaryReader): AddResult;
}

export namespace AddResult {
  export type AsObject = {
    cidsList: Array<avvyprotocol_base_pb.Cid.AsObject>,
    error: string,
  }
}

export class GetParameters extends jspb.Message {
  clearCidsList(): void;
  getCidsList(): Array<avvyprotocol_base_pb.Cid>;
  setCidsList(value: Array<avvyprotocol_base_pb.Cid>): void;
  addCids(value?: avvyprotocol_base_pb.Cid, index?: number): avvyprotocol_base_pb.Cid;

  hasBloomfilter(): boolean;
  clearBloomfilter(): void;
  getBloomfilter(): avvyprotocol_base_pb.BloomFilterArgs | undefined;
  setBloomfilter(value?: avvyprotocol_base_pb.BloomFilterArgs): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): GetParameters.AsObject;
  static toObject(includeInstance: boolean, msg: GetParameters): GetParameters.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: GetParameters, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): GetParameters;
  static deserializeBinaryFromReader(message: GetParameters, reader: jspb.BinaryReader): GetParameters;
}

export namespace GetParameters {
  export type AsObject = {
    cidsList: Array<avvyprotocol_base_pb.Cid.AsObject>,
    bloomfilter?: avvyprotocol_base_pb.BloomFilterArgs.AsObject,
  }
}

export class GetResult extends jspb.Message {
  hasData(): boolean;
  clearData(): void;
  getData(): avvyprotocol_base_pb.Data | undefined;
  setData(value?: avvyprotocol_base_pb.Data): void;

  getError(): string;
  setError(value: string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): GetResult.AsObject;
  static toObject(includeInstance: boolean, msg: GetResult): GetResult.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: GetResult, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): GetResult;
  static deserializeBinaryFromReader(message: GetResult, reader: jspb.BinaryReader): GetResult;
}

export namespace GetResult {
  export type AsObject = {
    data?: avvyprotocol_base_pb.Data.AsObject,
    error: string,
  }
}

export class FindParameters extends jspb.Message {
  hasTags(): boolean;
  clearTags(): void;
  getTags(): avvyprotocol_base_pb.Tags | undefined;
  setTags(value?: avvyprotocol_base_pb.Tags): void;

  getStart(): number;
  setStart(value: number): void;

  getLimit(): number;
  setLimit(value: number): void;

  getOnlycid(): boolean;
  setOnlycid(value: boolean): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): FindParameters.AsObject;
  static toObject(includeInstance: boolean, msg: FindParameters): FindParameters.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: FindParameters, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): FindParameters;
  static deserializeBinaryFromReader(message: FindParameters, reader: jspb.BinaryReader): FindParameters;
}

export namespace FindParameters {
  export type AsObject = {
    tags?: avvyprotocol_base_pb.Tags.AsObject,
    start: number,
    limit: number,
    onlycid: boolean,
  }
}

export class FindResult extends jspb.Message {
  hasData(): boolean;
  clearData(): void;
  getData(): avvyprotocol_base_pb.Data | undefined;
  setData(value?: avvyprotocol_base_pb.Data): void;

  clearCidlistList(): void;
  getCidlistList(): Array<avvyprotocol_base_pb.Cid>;
  setCidlistList(value: Array<avvyprotocol_base_pb.Cid>): void;
  addCidlist(value?: avvyprotocol_base_pb.Cid, index?: number): avvyprotocol_base_pb.Cid;

  getError(): string;
  setError(value: string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): FindResult.AsObject;
  static toObject(includeInstance: boolean, msg: FindResult): FindResult.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: FindResult, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): FindResult;
  static deserializeBinaryFromReader(message: FindResult, reader: jspb.BinaryReader): FindResult;
}

export namespace FindResult {
  export type AsObject = {
    data?: avvyprotocol_base_pb.Data.AsObject,
    cidlistList: Array<avvyprotocol_base_pb.Cid.AsObject>,
    error: string,
  }
}

