// package: relayer
// file: avvyprotocol/relayer.proto

import * as avvyprotocol_relayer_pb from "../avvyprotocol/relayer_pb";
import {grpc} from "@improbable-eng/grpc-web";

type RelayerProcess = {
  readonly methodName: string;
  readonly service: typeof Relayer;
  readonly requestStream: false;
  readonly responseStream: false;
  readonly requestType: typeof avvyprotocol_relayer_pb.ProcessParameters;
  readonly responseType: typeof avvyprotocol_relayer_pb.ProcessResult;
};

type RelayerAdd = {
  readonly methodName: string;
  readonly service: typeof Relayer;
  readonly requestStream: false;
  readonly responseStream: false;
  readonly requestType: typeof avvyprotocol_relayer_pb.AddParameters;
  readonly responseType: typeof avvyprotocol_relayer_pb.AddResult;
};

type RelayerGet = {
  readonly methodName: string;
  readonly service: typeof Relayer;
  readonly requestStream: false;
  readonly responseStream: false;
  readonly requestType: typeof avvyprotocol_relayer_pb.GetParameters;
  readonly responseType: typeof avvyprotocol_relayer_pb.GetResult;
};

type RelayerFind = {
  readonly methodName: string;
  readonly service: typeof Relayer;
  readonly requestStream: false;
  readonly responseStream: false;
  readonly requestType: typeof avvyprotocol_relayer_pb.FindParameters;
  readonly responseType: typeof avvyprotocol_relayer_pb.FindResult;
};

export class Relayer {
  static readonly serviceName: string;
  static readonly Process: RelayerProcess;
  static readonly Add: RelayerAdd;
  static readonly Get: RelayerGet;
  static readonly Find: RelayerFind;
}

export type ServiceError = { message: string, code: number; metadata: grpc.Metadata }
export type Status = { details: string, code: number; metadata: grpc.Metadata }

interface UnaryResponse {
  cancel(): void;
}
interface ResponseStream<T> {
  cancel(): void;
  on(type: 'data', handler: (message: T) => void): ResponseStream<T>;
  on(type: 'end', handler: (status?: Status) => void): ResponseStream<T>;
  on(type: 'status', handler: (status: Status) => void): ResponseStream<T>;
}
interface RequestStream<T> {
  write(message: T): RequestStream<T>;
  end(): void;
  cancel(): void;
  on(type: 'end', handler: (status?: Status) => void): RequestStream<T>;
  on(type: 'status', handler: (status: Status) => void): RequestStream<T>;
}
interface BidirectionalStream<ReqT, ResT> {
  write(message: ReqT): BidirectionalStream<ReqT, ResT>;
  end(): void;
  cancel(): void;
  on(type: 'data', handler: (message: ResT) => void): BidirectionalStream<ReqT, ResT>;
  on(type: 'end', handler: (status?: Status) => void): BidirectionalStream<ReqT, ResT>;
  on(type: 'status', handler: (status: Status) => void): BidirectionalStream<ReqT, ResT>;
}

export class RelayerClient {
  readonly serviceHost: string;

  constructor(serviceHost: string, options?: grpc.RpcOptions);
  process(
    requestMessage: avvyprotocol_relayer_pb.ProcessParameters,
    metadata: grpc.Metadata,
    callback: (error: ServiceError|null, responseMessage: avvyprotocol_relayer_pb.ProcessResult|null) => void
  ): UnaryResponse;
  process(
    requestMessage: avvyprotocol_relayer_pb.ProcessParameters,
    callback: (error: ServiceError|null, responseMessage: avvyprotocol_relayer_pb.ProcessResult|null) => void
  ): UnaryResponse;
  add(
    requestMessage: avvyprotocol_relayer_pb.AddParameters,
    metadata: grpc.Metadata,
    callback: (error: ServiceError|null, responseMessage: avvyprotocol_relayer_pb.AddResult|null) => void
  ): UnaryResponse;
  add(
    requestMessage: avvyprotocol_relayer_pb.AddParameters,
    callback: (error: ServiceError|null, responseMessage: avvyprotocol_relayer_pb.AddResult|null) => void
  ): UnaryResponse;
  get(
    requestMessage: avvyprotocol_relayer_pb.GetParameters,
    metadata: grpc.Metadata,
    callback: (error: ServiceError|null, responseMessage: avvyprotocol_relayer_pb.GetResult|null) => void
  ): UnaryResponse;
  get(
    requestMessage: avvyprotocol_relayer_pb.GetParameters,
    callback: (error: ServiceError|null, responseMessage: avvyprotocol_relayer_pb.GetResult|null) => void
  ): UnaryResponse;
  find(
    requestMessage: avvyprotocol_relayer_pb.FindParameters,
    metadata: grpc.Metadata,
    callback: (error: ServiceError|null, responseMessage: avvyprotocol_relayer_pb.FindResult|null) => void
  ): UnaryResponse;
  find(
    requestMessage: avvyprotocol_relayer_pb.FindParameters,
    callback: (error: ServiceError|null, responseMessage: avvyprotocol_relayer_pb.FindResult|null) => void
  ): UnaryResponse;
}

