// package: relayer
// file: avvyprotocol/relayer.proto

var avvyprotocol_relayer_pb = require("../avvyprotocol/relayer_pb");
var grpc = require("@improbable-eng/grpc-web").grpc;

var Relayer = (function () {
  function Relayer() {}
  Relayer.serviceName = "relayer.Relayer";
  return Relayer;
}());

Relayer.Process = {
  methodName: "Process",
  service: Relayer,
  requestStream: false,
  responseStream: false,
  requestType: avvyprotocol_relayer_pb.ProcessParameters,
  responseType: avvyprotocol_relayer_pb.ProcessResult
};

Relayer.Add = {
  methodName: "Add",
  service: Relayer,
  requestStream: false,
  responseStream: false,
  requestType: avvyprotocol_relayer_pb.AddParameters,
  responseType: avvyprotocol_relayer_pb.AddResult
};

Relayer.Get = {
  methodName: "Get",
  service: Relayer,
  requestStream: false,
  responseStream: false,
  requestType: avvyprotocol_relayer_pb.GetParameters,
  responseType: avvyprotocol_relayer_pb.GetResult
};

Relayer.Find = {
  methodName: "Find",
  service: Relayer,
  requestStream: false,
  responseStream: false,
  requestType: avvyprotocol_relayer_pb.FindParameters,
  responseType: avvyprotocol_relayer_pb.FindResult
};

exports.Relayer = Relayer;

function RelayerClient(serviceHost, options) {
  this.serviceHost = serviceHost;
  this.options = options || {};
}

RelayerClient.prototype.process = function process(requestMessage, metadata, callback) {
  if (arguments.length === 2) {
    callback = arguments[1];
  }
  var client = grpc.unary(Relayer.Process, {
    request: requestMessage,
    host: this.serviceHost,
    metadata: metadata,
    transport: this.options.transport,
    debug: this.options.debug,
    onEnd: function (response) {
      if (callback) {
        if (response.status !== grpc.Code.OK) {
          var err = new Error(response.statusMessage);
          err.code = response.status;
          err.metadata = response.trailers;
          callback(err, null);
        } else {
          callback(null, response.message);
        }
      }
    }
  });
  return {
    cancel: function () {
      callback = null;
      client.close();
    }
  };
};

RelayerClient.prototype.add = function add(requestMessage, metadata, callback) {
  if (arguments.length === 2) {
    callback = arguments[1];
  }
  var client = grpc.unary(Relayer.Add, {
    request: requestMessage,
    host: this.serviceHost,
    metadata: metadata,
    transport: this.options.transport,
    debug: this.options.debug,
    onEnd: function (response) {
      if (callback) {
        if (response.status !== grpc.Code.OK) {
          var err = new Error(response.statusMessage);
          err.code = response.status;
          err.metadata = response.trailers;
          callback(err, null);
        } else {
          callback(null, response.message);
        }
      }
    }
  });
  return {
    cancel: function () {
      callback = null;
      client.close();
    }
  };
};

RelayerClient.prototype.get = function get(requestMessage, metadata, callback) {
  if (arguments.length === 2) {
    callback = arguments[1];
  }
  var client = grpc.unary(Relayer.Get, {
    request: requestMessage,
    host: this.serviceHost,
    metadata: metadata,
    transport: this.options.transport,
    debug: this.options.debug,
    onEnd: function (response) {
      if (callback) {
        if (response.status !== grpc.Code.OK) {
          var err = new Error(response.statusMessage);
          err.code = response.status;
          err.metadata = response.trailers;
          callback(err, null);
        } else {
          callback(null, response.message);
        }
      }
    }
  });
  return {
    cancel: function () {
      callback = null;
      client.close();
    }
  };
};

RelayerClient.prototype.find = function find(requestMessage, metadata, callback) {
  if (arguments.length === 2) {
    callback = arguments[1];
  }
  var client = grpc.unary(Relayer.Find, {
    request: requestMessage,
    host: this.serviceHost,
    metadata: metadata,
    transport: this.options.transport,
    debug: this.options.debug,
    onEnd: function (response) {
      if (callback) {
        if (response.status !== grpc.Code.OK) {
          var err = new Error(response.statusMessage);
          err.code = response.status;
          err.metadata = response.trailers;
          callback(err, null);
        } else {
          callback(null, response.message);
        }
      }
    }
  });
  return {
    cancel: function () {
      callback = null;
      client.close();
    }
  };
};

exports.RelayerClient = RelayerClient;

