// package: ucsProcess
// file: avvyprotocol/ucsProcess.proto

import * as jspb from "google-protobuf";
import * as avvyprotocol_ucsmodel_pb from "../avvyprotocol/ucsmodel_pb";

export class UCSProcessRequest extends jspb.Message {
  clearUcsworkerinstructionList(): void;
  getUcsworkerinstructionList(): Array<UCSWorkerInstruction>;
  setUcsworkerinstructionList(value: Array<UCSWorkerInstruction>): void;
  addUcsworkerinstruction(value?: UCSWorkerInstruction, index?: number): UCSWorkerInstruction;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): UCSProcessRequest.AsObject;
  static toObject(includeInstance: boolean, msg: UCSProcessRequest): UCSProcessRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: UCSProcessRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): UCSProcessRequest;
  static deserializeBinaryFromReader(message: UCSProcessRequest, reader: jspb.BinaryReader): UCSProcessRequest;
}

export namespace UCSProcessRequest {
  export type AsObject = {
    ucsworkerinstructionList: Array<UCSWorkerInstruction.AsObject>,
  }
}

export class UCSProcessResponse extends jspb.Message {
  clearUcsprocessinstructionresponseList(): void;
  getUcsprocessinstructionresponseList(): Array<UCSProcessInstructionResponse>;
  setUcsprocessinstructionresponseList(value: Array<UCSProcessInstructionResponse>): void;
  addUcsprocessinstructionresponse(value?: UCSProcessInstructionResponse, index?: number): UCSProcessInstructionResponse;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): UCSProcessResponse.AsObject;
  static toObject(includeInstance: boolean, msg: UCSProcessResponse): UCSProcessResponse.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: UCSProcessResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): UCSProcessResponse;
  static deserializeBinaryFromReader(message: UCSProcessResponse, reader: jspb.BinaryReader): UCSProcessResponse;
}

export namespace UCSProcessResponse {
  export type AsObject = {
    ucsprocessinstructionresponseList: Array<UCSProcessInstructionResponse.AsObject>,
  }
}

export class UCSProcessInstructionResponse extends jspb.Message {
  hasError(): boolean;
  clearError(): void;
  getError(): string;
  setError(value: string): void;

  hasResult(): boolean;
  clearResult(): void;
  getResult(): UCSWorkerResult | undefined;
  setResult(value?: UCSWorkerResult): void;

  getResponseCase(): UCSProcessInstructionResponse.ResponseCase;
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): UCSProcessInstructionResponse.AsObject;
  static toObject(includeInstance: boolean, msg: UCSProcessInstructionResponse): UCSProcessInstructionResponse.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: UCSProcessInstructionResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): UCSProcessInstructionResponse;
  static deserializeBinaryFromReader(message: UCSProcessInstructionResponse, reader: jspb.BinaryReader): UCSProcessInstructionResponse;
}

export namespace UCSProcessInstructionResponse {
  export type AsObject = {
    error: string,
    result?: UCSWorkerResult.AsObject,
  }

  export enum ResponseCase {
    RESPONSE_NOT_SET = 0,
    ERROR = 1,
    RESULT = 2,
  }
}

export class UCSWorkerInstruction extends jspb.Message {
  hasModelimportinstruction(): boolean;
  clearModelimportinstruction(): void;
  getModelimportinstruction(): ModelImportInstruction | undefined;
  setModelimportinstruction(value?: ModelImportInstruction): void;

  hasImagecompressioninstruction(): boolean;
  clearImagecompressioninstruction(): void;
  getImagecompressioninstruction(): ImageCompressionInstruction | undefined;
  setImagecompressioninstruction(value?: ImageCompressionInstruction): void;

  hasBlockcellscalculationinstruction(): boolean;
  clearBlockcellscalculationinstruction(): void;
  getBlockcellscalculationinstruction(): BlockCellsCalculationInstruction | undefined;
  setBlockcellscalculationinstruction(value?: BlockCellsCalculationInstruction): void;

  getInstructionCase(): UCSWorkerInstruction.InstructionCase;
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): UCSWorkerInstruction.AsObject;
  static toObject(includeInstance: boolean, msg: UCSWorkerInstruction): UCSWorkerInstruction.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: UCSWorkerInstruction, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): UCSWorkerInstruction;
  static deserializeBinaryFromReader(message: UCSWorkerInstruction, reader: jspb.BinaryReader): UCSWorkerInstruction;
}

export namespace UCSWorkerInstruction {
  export type AsObject = {
    modelimportinstruction?: ModelImportInstruction.AsObject,
    imagecompressioninstruction?: ImageCompressionInstruction.AsObject,
    blockcellscalculationinstruction?: BlockCellsCalculationInstruction.AsObject,
  }

  export enum InstructionCase {
    INSTRUCTION_NOT_SET = 0,
    MODELIMPORTINSTRUCTION = 1,
    IMAGECOMPRESSIONINSTRUCTION = 2,
    BLOCKCELLSCALCULATIONINSTRUCTION = 3,
  }
}

export class UCSWorkerResult extends jspb.Message {
  clearElementsList(): void;
  getElementsList(): Array<UCSWorkerResultElement>;
  setElementsList(value: Array<UCSWorkerResultElement>): void;
  addElements(value?: UCSWorkerResultElement, index?: number): UCSWorkerResultElement;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): UCSWorkerResult.AsObject;
  static toObject(includeInstance: boolean, msg: UCSWorkerResult): UCSWorkerResult.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: UCSWorkerResult, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): UCSWorkerResult;
  static deserializeBinaryFromReader(message: UCSWorkerResult, reader: jspb.BinaryReader): UCSWorkerResult;
}

export namespace UCSWorkerResult {
  export type AsObject = {
    elementsList: Array<UCSWorkerResultElement.AsObject>,
  }
}

export class UCSWorkerResultElement extends jspb.Message {
  hasContentid(): boolean;
  clearContentid(): void;
  getContentid(): avvyprotocol_ucsmodel_pb.UCSObjectId | undefined;
  setContentid(value?: avvyprotocol_ucsmodel_pb.UCSObjectId): void;

  hasContent(): boolean;
  clearContent(): void;
  getContent(): avvyprotocol_ucsmodel_pb.StaticContent | undefined;
  setContent(value?: avvyprotocol_ucsmodel_pb.StaticContent): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): UCSWorkerResultElement.AsObject;
  static toObject(includeInstance: boolean, msg: UCSWorkerResultElement): UCSWorkerResultElement.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: UCSWorkerResultElement, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): UCSWorkerResultElement;
  static deserializeBinaryFromReader(message: UCSWorkerResultElement, reader: jspb.BinaryReader): UCSWorkerResultElement;
}

export namespace UCSWorkerResultElement {
  export type AsObject = {
    contentid?: avvyprotocol_ucsmodel_pb.UCSObjectId.AsObject,
    content?: avvyprotocol_ucsmodel_pb.StaticContent.AsObject,
  }
}

export class RawFile extends jspb.Message {
  getFileformat(): FileFormatsMap[keyof FileFormatsMap];
  setFileformat(value: FileFormatsMap[keyof FileFormatsMap]): void;

  getFile(): Uint8Array | string;
  getFile_asU8(): Uint8Array;
  getFile_asB64(): string;
  setFile(value: Uint8Array | string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): RawFile.AsObject;
  static toObject(includeInstance: boolean, msg: RawFile): RawFile.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: RawFile, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): RawFile;
  static deserializeBinaryFromReader(message: RawFile, reader: jspb.BinaryReader): RawFile;
}

export namespace RawFile {
  export type AsObject = {
    fileformat: FileFormatsMap[keyof FileFormatsMap],
    file: Uint8Array | string,
  }
}

export class ModelImportInstruction extends jspb.Message {
  hasModel(): boolean;
  clearModel(): void;
  getModel(): RawFile | undefined;
  setModel(value?: RawFile): void;

  getTextureimportoption(): ModelImportInstruction.InstrTextureImportOptionMap[keyof ModelImportInstruction.InstrTextureImportOptionMap];
  setTextureimportoption(value: ModelImportInstruction.InstrTextureImportOptionMap[keyof ModelImportInstruction.InstrTextureImportOptionMap]): void;

  getBlockcellsoption(): ModelImportInstruction.InstrBlockCellsOptionMap[keyof ModelImportInstruction.InstrBlockCellsOptionMap];
  setBlockcellsoption(value: ModelImportInstruction.InstrBlockCellsOptionMap[keyof ModelImportInstruction.InstrBlockCellsOptionMap]): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ModelImportInstruction.AsObject;
  static toObject(includeInstance: boolean, msg: ModelImportInstruction): ModelImportInstruction.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ModelImportInstruction, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ModelImportInstruction;
  static deserializeBinaryFromReader(message: ModelImportInstruction, reader: jspb.BinaryReader): ModelImportInstruction;
}

export namespace ModelImportInstruction {
  export type AsObject = {
    model?: RawFile.AsObject,
    textureimportoption: ModelImportInstruction.InstrTextureImportOptionMap[keyof ModelImportInstruction.InstrTextureImportOptionMap],
    blockcellsoption: ModelImportInstruction.InstrBlockCellsOptionMap[keyof ModelImportInstruction.InstrBlockCellsOptionMap],
  }

  export interface InstrTextureImportOptionMap {
    TXTIMP_COMPRESS_TO_GPU_FORMATS: 0;
    TXTIMP_IMPORT_ONLY_PNG: 1;
  }

  export const InstrTextureImportOption: InstrTextureImportOptionMap;

  export interface InstrBlockCellsOptionMap {
    BC_CALCULATE_BLOCK_CELLS: 0;
    BC_SKIP_BLOCK_CELLS_CALCULATION: 1;
  }

  export const InstrBlockCellsOption: InstrBlockCellsOptionMap;
}

export class ImageCompressionInstruction extends jspb.Message {
  hasImage(): boolean;
  clearImage(): void;
  getImage(): RawFile | undefined;
  setImage(value?: RawFile): void;

  getFlipimage(): ImageCompressionInstruction.InstrFlipImageOptionMap[keyof ImageCompressionInstruction.InstrFlipImageOptionMap];
  setFlipimage(value: ImageCompressionInstruction.InstrFlipImageOptionMap[keyof ImageCompressionInstruction.InstrFlipImageOptionMap]): void;

  getTextureresizeoption(): ImageCompressionInstruction.InstrTextureResizeOptionMap[keyof ImageCompressionInstruction.InstrTextureResizeOptionMap];
  setTextureresizeoption(value: ImageCompressionInstruction.InstrTextureResizeOptionMap[keyof ImageCompressionInstruction.InstrTextureResizeOptionMap]): void;

  getMipmapoption(): ImageCompressionInstruction.InstrMipmapsOptionMap[keyof ImageCompressionInstruction.InstrMipmapsOptionMap];
  setMipmapoption(value: ImageCompressionInstruction.InstrMipmapsOptionMap[keyof ImageCompressionInstruction.InstrMipmapsOptionMap]): void;

  getPostprocessingoption(): ImageCompressionInstruction.InstrPostprocessingOptionMap[keyof ImageCompressionInstruction.InstrPostprocessingOptionMap];
  setPostprocessingoption(value: ImageCompressionInstruction.InstrPostprocessingOptionMap[keyof ImageCompressionInstruction.InstrPostprocessingOptionMap]): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ImageCompressionInstruction.AsObject;
  static toObject(includeInstance: boolean, msg: ImageCompressionInstruction): ImageCompressionInstruction.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ImageCompressionInstruction, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ImageCompressionInstruction;
  static deserializeBinaryFromReader(message: ImageCompressionInstruction, reader: jspb.BinaryReader): ImageCompressionInstruction;
}

export namespace ImageCompressionInstruction {
  export type AsObject = {
    image?: RawFile.AsObject,
    flipimage: ImageCompressionInstruction.InstrFlipImageOptionMap[keyof ImageCompressionInstruction.InstrFlipImageOptionMap],
    textureresizeoption: ImageCompressionInstruction.InstrTextureResizeOptionMap[keyof ImageCompressionInstruction.InstrTextureResizeOptionMap],
    mipmapoption: ImageCompressionInstruction.InstrMipmapsOptionMap[keyof ImageCompressionInstruction.InstrMipmapsOptionMap],
    postprocessingoption: ImageCompressionInstruction.InstrPostprocessingOptionMap[keyof ImageCompressionInstruction.InstrPostprocessingOptionMap],
  }

  export interface InstrTextureResizeOptionMap {
    TXT_POWER_OF_TWO: 0;
    TXT_NO_RESIZE: 1;
    TXT_SMALL_AND_LARGE_PREVIEW: 2;
    TXT_SMALL_PREVIEW: 3;
    TXT_LARGE_PREVIEW: 4;
  }

  export const InstrTextureResizeOption: InstrTextureResizeOptionMap;

  export interface InstrFlipImageOptionMap {
    FLP_FLIP_ALL: 0;
    FLP_FLIP_ONLY_GPU_TEX: 1;
    FLP_NO_FLIP: 2;
  }

  export const InstrFlipImageOption: InstrFlipImageOptionMap;

  export interface InstrMipmapsOptionMap {
    MM_ALL_MIPMAPS: 0;
    MM_NO_MIPMAPS: 1;
  }

  export const InstrMipmapsOption: InstrMipmapsOptionMap;

  export interface InstrPostprocessingOptionMap {
    PP_NO_POSTPROCESS: 0;
    PP_CROP_CIRCLE: 1;
  }

  export const InstrPostprocessingOption: InstrPostprocessingOptionMap;
}

export class BlockCellsCalculationInstruction extends jspb.Message {
  clearPositionedmeshesList(): void;
  getPositionedmeshesList(): Array<BlockCellsCalculationInstruction.PositionedMesh>;
  setPositionedmeshesList(value: Array<BlockCellsCalculationInstruction.PositionedMesh>): void;
  addPositionedmeshes(value?: BlockCellsCalculationInstruction.PositionedMesh, index?: number): BlockCellsCalculationInstruction.PositionedMesh;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): BlockCellsCalculationInstruction.AsObject;
  static toObject(includeInstance: boolean, msg: BlockCellsCalculationInstruction): BlockCellsCalculationInstruction.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: BlockCellsCalculationInstruction, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): BlockCellsCalculationInstruction;
  static deserializeBinaryFromReader(message: BlockCellsCalculationInstruction, reader: jspb.BinaryReader): BlockCellsCalculationInstruction;
}

export namespace BlockCellsCalculationInstruction {
  export type AsObject = {
    positionedmeshesList: Array<BlockCellsCalculationInstruction.PositionedMesh.AsObject>,
  }

  export class PositionedMesh extends jspb.Message {
    clearTransformList(): void;
    getTransformList(): Array<number>;
    setTransformList(value: Array<number>): void;
    addTransform(value: number, index?: number): number;

    hasMesh(): boolean;
    clearMesh(): void;
    getMesh(): avvyprotocol_ucsmodel_pb.Mesh | undefined;
    setMesh(value?: avvyprotocol_ucsmodel_pb.Mesh): void;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): PositionedMesh.AsObject;
    static toObject(includeInstance: boolean, msg: PositionedMesh): PositionedMesh.AsObject;
    static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
    static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
    static serializeBinaryToWriter(message: PositionedMesh, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): PositionedMesh;
    static deserializeBinaryFromReader(message: PositionedMesh, reader: jspb.BinaryReader): PositionedMesh;
  }

  export namespace PositionedMesh {
    export type AsObject = {
      transformList: Array<number>,
      mesh?: avvyprotocol_ucsmodel_pb.Mesh.AsObject,
    }
  }
}

export interface FileFormatsMap {
  FMT_PNG: 0;
  FMT_GLB: 1;
}

export const FileFormats: FileFormatsMap;

