// package: ucsProcess
// file: avvyprotocol/ucsProcess.proto

import * as avvyprotocol_ucsProcess_pb from "../avvyprotocol/ucsProcess_pb";
import {grpc} from "@improbable-eng/grpc-web";

type UCSProcessProcess = {
  readonly methodName: string;
  readonly service: typeof UCSProcess;
  readonly requestStream: false;
  readonly responseStream: false;
  readonly requestType: typeof avvyprotocol_ucsProcess_pb.UCSProcessRequest;
  readonly responseType: typeof avvyprotocol_ucsProcess_pb.UCSProcessResponse;
};

export class UCSProcess {
  static readonly serviceName: string;
  static readonly Process: UCSProcessProcess;
}

export type ServiceError = { message: string, code: number; metadata: grpc.Metadata }
export type Status = { details: string, code: number; metadata: grpc.Metadata }

interface UnaryResponse {
  cancel(): void;
}
interface ResponseStream<T> {
  cancel(): void;
  on(type: 'data', handler: (message: T) => void): ResponseStream<T>;
  on(type: 'end', handler: (status?: Status) => void): ResponseStream<T>;
  on(type: 'status', handler: (status: Status) => void): ResponseStream<T>;
}
interface RequestStream<T> {
  write(message: T): RequestStream<T>;
  end(): void;
  cancel(): void;
  on(type: 'end', handler: (status?: Status) => void): RequestStream<T>;
  on(type: 'status', handler: (status: Status) => void): RequestStream<T>;
}
interface BidirectionalStream<ReqT, ResT> {
  write(message: ReqT): BidirectionalStream<ReqT, ResT>;
  end(): void;
  cancel(): void;
  on(type: 'data', handler: (message: ResT) => void): BidirectionalStream<ReqT, ResT>;
  on(type: 'end', handler: (status?: Status) => void): BidirectionalStream<ReqT, ResT>;
  on(type: 'status', handler: (status: Status) => void): BidirectionalStream<ReqT, ResT>;
}

export class UCSProcessClient {
  readonly serviceHost: string;

  constructor(serviceHost: string, options?: grpc.RpcOptions);
  process(
    requestMessage: avvyprotocol_ucsProcess_pb.UCSProcessRequest,
    metadata: grpc.Metadata,
    callback: (error: ServiceError|null, responseMessage: avvyprotocol_ucsProcess_pb.UCSProcessResponse|null) => void
  ): UnaryResponse;
  process(
    requestMessage: avvyprotocol_ucsProcess_pb.UCSProcessRequest,
    callback: (error: ServiceError|null, responseMessage: avvyprotocol_ucsProcess_pb.UCSProcessResponse|null) => void
  ): UnaryResponse;
}

