// package: ucsProcess
// file: avvyprotocol/ucsProcess.proto

var avvyprotocol_ucsProcess_pb = require("../avvyprotocol/ucsProcess_pb");
var grpc = require("@improbable-eng/grpc-web").grpc;

var UCSProcess = (function () {
  function UCSProcess() {}
  UCSProcess.serviceName = "ucsProcess.UCSProcess";
  return UCSProcess;
}());

UCSProcess.Process = {
  methodName: "Process",
  service: UCSProcess,
  requestStream: false,
  responseStream: false,
  requestType: avvyprotocol_ucsProcess_pb.UCSProcessRequest,
  responseType: avvyprotocol_ucsProcess_pb.UCSProcessResponse
};

exports.UCSProcess = UCSProcess;

function UCSProcessClient(serviceHost, options) {
  this.serviceHost = serviceHost;
  this.options = options || {};
}

UCSProcessClient.prototype.process = function process(requestMessage, metadata, callback) {
  if (arguments.length === 2) {
    callback = arguments[1];
  }
  var client = grpc.unary(UCSProcess.Process, {
    request: requestMessage,
    host: this.serviceHost,
    metadata: metadata,
    transport: this.options.transport,
    debug: this.options.debug,
    onEnd: function (response) {
      if (callback) {
        if (response.status !== grpc.Code.OK) {
          var err = new Error(response.statusMessage);
          err.code = response.status;
          err.metadata = response.trailers;
          callback(err, null);
        } else {
          callback(null, response.message);
        }
      }
    }
  });
  return {
    cancel: function () {
      callback = null;
      client.close();
    }
  };
};

exports.UCSProcessClient = UCSProcessClient;

