// package: ucs
// file: avvyprotocol/ucsmodel.proto

import * as jspb from "google-protobuf";
import * as avvyprotocol_base_pb from "../avvyprotocol/base_pb";

export class StaticContent extends jspb.Message {
  getVersion(): number;
  setVersion(value: number): void;

  hasContentmetadata(): boolean;
  clearContentmetadata(): void;
  getContentmetadata(): ContentMetadata | undefined;
  setContentmetadata(value?: ContentMetadata): void;

  hasSceneobject(): boolean;
  clearSceneobject(): void;
  getSceneobject(): SceneObject | undefined;
  setSceneobject(value?: SceneObject): void;

  hasMesh(): boolean;
  clearMesh(): void;
  getMesh(): Mesh | undefined;
  setMesh(value?: Mesh): void;

  hasMaterial(): boolean;
  clearMaterial(): void;
  getMaterial(): Material | undefined;
  setMaterial(value?: Material): void;

  hasImage(): boolean;
  clearImage(): void;
  getImage(): Image | undefined;
  setImage(value?: Image): void;

  hasEffect(): boolean;
  clearEffect(): void;
  getEffect(): Effect | undefined;
  setEffect(value?: Effect): void;

  hasBlockcells(): boolean;
  clearBlockcells(): void;
  getBlockcells(): BlockCells | undefined;
  setBlockcells(value?: BlockCells): void;

  hasSampledanimationtoviews(): boolean;
  clearSampledanimationtoviews(): void;
  getSampledanimationtoviews(): SampledAnimationToViews | undefined;
  setSampledanimationtoviews(value?: SampledAnimationToViews): void;

  getAssetCase(): StaticContent.AssetCase;
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): StaticContent.AsObject;
  static toObject(includeInstance: boolean, msg: StaticContent): StaticContent.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: StaticContent, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): StaticContent;
  static deserializeBinaryFromReader(message: StaticContent, reader: jspb.BinaryReader): StaticContent;
}

export namespace StaticContent {
  export type AsObject = {
    version: number,
    contentmetadata?: ContentMetadata.AsObject,
    sceneobject?: SceneObject.AsObject,
    mesh?: Mesh.AsObject,
    material?: Material.AsObject,
    image?: Image.AsObject,
    effect?: Effect.AsObject,
    blockcells?: BlockCells.AsObject,
    sampledanimationtoviews?: SampledAnimationToViews.AsObject,
  }

  export enum AssetCase {
    ASSET_NOT_SET = 0,
    CONTENTMETADATA = 2,
    SCENEOBJECT = 3,
    MESH = 4,
    MATERIAL = 5,
    IMAGE = 6,
    EFFECT = 7,
    BLOCKCELLS = 8,
    SAMPLEDANIMATIONTOVIEWS = 9,
  }
}

export class UCSObjectId extends jspb.Message {
  hasCid(): boolean;
  clearCid(): void;
  getCid(): avvyprotocol_base_pb.Cid | undefined;
  setCid(value?: avvyprotocol_base_pb.Cid): void;

  hasHashid(): boolean;
  clearHashid(): void;
  getHashid(): UCSHashId | undefined;
  setHashid(value?: UCSHashId): void;

  getIdCase(): UCSObjectId.IdCase;
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): UCSObjectId.AsObject;
  static toObject(includeInstance: boolean, msg: UCSObjectId): UCSObjectId.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: UCSObjectId, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): UCSObjectId;
  static deserializeBinaryFromReader(message: UCSObjectId, reader: jspb.BinaryReader): UCSObjectId;
}

export namespace UCSObjectId {
  export type AsObject = {
    cid?: avvyprotocol_base_pb.Cid.AsObject,
    hashid?: UCSHashId.AsObject,
  }

  export enum IdCase {
    ID_NOT_SET = 0,
    CID = 1,
    HASHID = 2,
  }
}

export class UCSHashId extends jspb.Message {
  getValue(): Uint8Array | string;
  getValue_asU8(): Uint8Array;
  getValue_asB64(): string;
  setValue(value: Uint8Array | string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): UCSHashId.AsObject;
  static toObject(includeInstance: boolean, msg: UCSHashId): UCSHashId.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: UCSHashId, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): UCSHashId;
  static deserializeBinaryFromReader(message: UCSHashId, reader: jspb.BinaryReader): UCSHashId;
}

export namespace UCSHashId {
  export type AsObject = {
    value: Uint8Array | string,
  }
}

export class SceneObject extends jspb.Message {
  clearViewsList(): void;
  getViewsList(): Array<View>;
  setViewsList(value: Array<View>): void;
  addViews(value?: View, index?: number): View;

  hasCollider(): boolean;
  clearCollider(): void;
  getCollider(): UCSObjectId | undefined;
  setCollider(value?: UCSObjectId): void;

  hasBlockcells(): boolean;
  clearBlockcells(): void;
  getBlockcells(): UCSObjectId | undefined;
  setBlockcells(value?: UCSObjectId): void;

  hasSampledanimationtoviews(): boolean;
  clearSampledanimationtoviews(): void;
  getSampledanimationtoviews(): UCSObjectId | undefined;
  setSampledanimationtoviews(value?: UCSObjectId): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): SceneObject.AsObject;
  static toObject(includeInstance: boolean, msg: SceneObject): SceneObject.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: SceneObject, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): SceneObject;
  static deserializeBinaryFromReader(message: SceneObject, reader: jspb.BinaryReader): SceneObject;
}

export namespace SceneObject {
  export type AsObject = {
    viewsList: Array<View.AsObject>,
    collider?: UCSObjectId.AsObject,
    blockcells?: UCSObjectId.AsObject,
    sampledanimationtoviews?: UCSObjectId.AsObject,
  }
}

export class View extends jspb.Message {
  clearChildrenList(): void;
  getChildrenList(): Array<Child>;
  setChildrenList(value: Array<Child>): void;
  addChildren(value?: Child, index?: number): Child;

  hasRenderbounds(): boolean;
  clearRenderbounds(): void;
  getRenderbounds(): RenderBounds | undefined;
  setRenderbounds(value?: RenderBounds): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): View.AsObject;
  static toObject(includeInstance: boolean, msg: View): View.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: View, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): View;
  static deserializeBinaryFromReader(message: View, reader: jspb.BinaryReader): View;
}

export namespace View {
  export type AsObject = {
    childrenList: Array<Child.AsObject>,
    renderbounds?: RenderBounds.AsObject,
  }
}

export class Child extends jspb.Message {
  clearTransformList(): void;
  getTransformList(): Array<number>;
  setTransformList(value: Array<number>): void;
  addTransform(value: number, index?: number): number;

  hasMeshchild(): boolean;
  clearMeshchild(): void;
  getMeshchild(): MeshChild | undefined;
  setMeshchild(value?: MeshChild): void;

  hasSocketchild(): boolean;
  clearSocketchild(): void;
  getSocketchild(): SocketChild | undefined;
  setSocketchild(value?: SocketChild): void;

  getPropertyCase(): Child.PropertyCase;
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): Child.AsObject;
  static toObject(includeInstance: boolean, msg: Child): Child.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: Child, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): Child;
  static deserializeBinaryFromReader(message: Child, reader: jspb.BinaryReader): Child;
}

export namespace Child {
  export type AsObject = {
    transformList: Array<number>,
    meshchild?: MeshChild.AsObject,
    socketchild?: SocketChild.AsObject,
  }

  export enum PropertyCase {
    PROPERTY_NOT_SET = 0,
    MESHCHILD = 2,
    SOCKETCHILD = 3,
  }
}

export class RenderBounds extends jspb.Message {
  clearCenterList(): void;
  getCenterList(): Array<number>;
  setCenterList(value: Array<number>): void;
  addCenter(value: number, index?: number): number;

  clearExtentsList(): void;
  getExtentsList(): Array<number>;
  setExtentsList(value: Array<number>): void;
  addExtents(value: number, index?: number): number;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): RenderBounds.AsObject;
  static toObject(includeInstance: boolean, msg: RenderBounds): RenderBounds.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: RenderBounds, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): RenderBounds;
  static deserializeBinaryFromReader(message: RenderBounds, reader: jspb.BinaryReader): RenderBounds;
}

export namespace RenderBounds {
  export type AsObject = {
    centerList: Array<number>,
    extentsList: Array<number>,
  }
}

export class MeshChild extends jspb.Message {
  clearMeshbylodlevelList(): void;
  getMeshbylodlevelList(): Array<UCSObjectId>;
  setMeshbylodlevelList(value: Array<UCSObjectId>): void;
  addMeshbylodlevel(value?: UCSObjectId, index?: number): UCSObjectId;

  hasMaterial(): boolean;
  clearMaterial(): void;
  getMaterial(): UCSObjectId | undefined;
  setMaterial(value?: UCSObjectId): void;

  getCastshadows(): boolean;
  setCastshadows(value: boolean): void;

  getReceiveshadows(): boolean;
  setReceiveshadows(value: boolean): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): MeshChild.AsObject;
  static toObject(includeInstance: boolean, msg: MeshChild): MeshChild.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: MeshChild, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): MeshChild;
  static deserializeBinaryFromReader(message: MeshChild, reader: jspb.BinaryReader): MeshChild;
}

export namespace MeshChild {
  export type AsObject = {
    meshbylodlevelList: Array<UCSObjectId.AsObject>,
    material?: UCSObjectId.AsObject,
    castshadows: boolean,
    receiveshadows: boolean,
  }
}

export class SocketChild extends jspb.Message {
  getSocketname(): string;
  setSocketname(value: string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): SocketChild.AsObject;
  static toObject(includeInstance: boolean, msg: SocketChild): SocketChild.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: SocketChild, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): SocketChild;
  static deserializeBinaryFromReader(message: SocketChild, reader: jspb.BinaryReader): SocketChild;
}

export namespace SocketChild {
  export type AsObject = {
    socketname: string,
  }
}

export class Mesh extends jspb.Message {
  clearVerticesList(): void;
  getVerticesList(): Array<number>;
  setVerticesList(value: Array<number>): void;
  addVertices(value: number, index?: number): number;

  clearNormalsList(): void;
  getNormalsList(): Array<number>;
  setNormalsList(value: Array<number>): void;
  addNormals(value: number, index?: number): number;

  clearUvList(): void;
  getUvList(): Array<number>;
  setUvList(value: Array<number>): void;
  addUv(value: number, index?: number): number;

  clearFacesList(): void;
  getFacesList(): Array<number>;
  setFacesList(value: Array<number>): void;
  addFaces(value: number, index?: number): number;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): Mesh.AsObject;
  static toObject(includeInstance: boolean, msg: Mesh): Mesh.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: Mesh, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): Mesh;
  static deserializeBinaryFromReader(message: Mesh, reader: jspb.BinaryReader): Mesh;
}

export namespace Mesh {
  export type AsObject = {
    verticesList: Array<number>,
    normalsList: Array<number>,
    uvList: Array<number>,
    facesList: Array<number>,
  }
}

export class Material extends jspb.Message {
  getRoughness(): number;
  setRoughness(value: number): void;

  hasRoughnessmap(): boolean;
  clearRoughnessmap(): void;
  getRoughnessmap(): TextureMap | undefined;
  setRoughnessmap(value?: TextureMap): void;

  getMetalness(): number;
  setMetalness(value: number): void;

  hasMetalnessmap(): boolean;
  clearMetalnessmap(): void;
  getMetalnessmap(): TextureMap | undefined;
  setMetalnessmap(value?: TextureMap): void;

  getColor(): string;
  setColor(value: string): void;

  hasMap(): boolean;
  clearMap(): void;
  getMap(): TextureMap | undefined;
  setMap(value?: TextureMap): void;

  getEmissive(): string;
  setEmissive(value: string): void;

  hasEmissivemap(): boolean;
  clearEmissivemap(): void;
  getEmissivemap(): TextureMap | undefined;
  setEmissivemap(value?: TextureMap): void;

  getEmissiveintensity(): number;
  setEmissiveintensity(value: number): void;

  hasAomap(): boolean;
  clearAomap(): void;
  getAomap(): TextureMap | undefined;
  setAomap(value?: TextureMap): void;

  getAomapintensity(): number;
  setAomapintensity(value: number): void;

  hasNormalmap(): boolean;
  clearNormalmap(): void;
  getNormalmap(): TextureMap | undefined;
  setNormalmap(value?: TextureMap): void;

  clearNormalscaleList(): void;
  getNormalscaleList(): Array<number>;
  setNormalscaleList(value: Array<number>): void;
  addNormalscale(value: number, index?: number): number;

  hasEnvmap(): boolean;
  clearEnvmap(): void;
  getEnvmap(): TextureMap | undefined;
  setEnvmap(value?: TextureMap): void;

  getEnvmapintensity(): number;
  setEnvmapintensity(value: number): void;

  getTransparent(): boolean;
  setTransparent(value: boolean): void;

  getOpacity(): number;
  setOpacity(value: number): void;

  getSide(): SideMap[keyof SideMap];
  setSide(value: SideMap[keyof SideMap]): void;

  getBlending(): MaterialBlendingMap[keyof MaterialBlendingMap];
  setBlending(value: MaterialBlendingMap[keyof MaterialBlendingMap]): void;

  getAlphatest(): number;
  setAlphatest(value: number): void;

  clearEffectsList(): void;
  getEffectsList(): Array<Effect>;
  setEffectsList(value: Array<Effect>): void;
  addEffects(value?: Effect, index?: number): Effect;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): Material.AsObject;
  static toObject(includeInstance: boolean, msg: Material): Material.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: Material, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): Material;
  static deserializeBinaryFromReader(message: Material, reader: jspb.BinaryReader): Material;
}

export namespace Material {
  export type AsObject = {
    roughness: number,
    roughnessmap?: TextureMap.AsObject,
    metalness: number,
    metalnessmap?: TextureMap.AsObject,
    color: string,
    map?: TextureMap.AsObject,
    emissive: string,
    emissivemap?: TextureMap.AsObject,
    emissiveintensity: number,
    aomap?: TextureMap.AsObject,
    aomapintensity: number,
    normalmap?: TextureMap.AsObject,
    normalscaleList: Array<number>,
    envmap?: TextureMap.AsObject,
    envmapintensity: number,
    transparent: boolean,
    opacity: number,
    side: SideMap[keyof SideMap],
    blending: MaterialBlendingMap[keyof MaterialBlendingMap],
    alphatest: number,
    effectsList: Array<Effect.AsObject>,
  }
}

export class TextureMap extends jspb.Message {
  clearImagesList(): void;
  getImagesList(): Array<UCSObjectId>;
  setImagesList(value: Array<UCSObjectId>): void;
  addImages(value?: UCSObjectId, index?: number): UCSObjectId;

  clearRepeatList(): void;
  getRepeatList(): Array<number>;
  setRepeatList(value: Array<number>): void;
  addRepeat(value: number, index?: number): number;

  clearOffsetList(): void;
  getOffsetList(): Array<number>;
  setOffsetList(value: Array<number>): void;
  addOffset(value: number, index?: number): number;

  clearSizeList(): void;
  getSizeList(): Array<number>;
  setSizeList(value: Array<number>): void;
  addSize(value: number, index?: number): number;

  getRotation(): number;
  setRotation(value: number): void;

  clearCenterList(): void;
  getCenterList(): Array<number>;
  setCenterList(value: Array<number>): void;
  addCenter(value: number, index?: number): number;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): TextureMap.AsObject;
  static toObject(includeInstance: boolean, msg: TextureMap): TextureMap.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: TextureMap, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): TextureMap;
  static deserializeBinaryFromReader(message: TextureMap, reader: jspb.BinaryReader): TextureMap;
}

export namespace TextureMap {
  export type AsObject = {
    imagesList: Array<UCSObjectId.AsObject>,
    repeatList: Array<number>,
    offsetList: Array<number>,
    sizeList: Array<number>,
    rotation: number,
    centerList: Array<number>,
  }
}

export class Image extends jspb.Message {
  getFile(): Uint8Array | string;
  getFile_asU8(): Uint8Array;
  getFile_asB64(): string;
  setFile(value: Uint8Array | string): void;

  getTextureformat(): TexFormatMap[keyof TexFormatMap];
  setTextureformat(value: TexFormatMap[keyof TexFormatMap]): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): Image.AsObject;
  static toObject(includeInstance: boolean, msg: Image): Image.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: Image, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): Image;
  static deserializeBinaryFromReader(message: Image, reader: jspb.BinaryReader): Image;
}

export namespace Image {
  export type AsObject = {
    file: Uint8Array | string,
    textureformat: TexFormatMap[keyof TexFormatMap],
  }
}

export class Effect extends jspb.Message {
  hasWatereffect(): boolean;
  clearWatereffect(): void;
  getWatereffect(): WaterEffect | undefined;
  setWatereffect(value?: WaterEffect): void;

  hasColormapeffect(): boolean;
  clearColormapeffect(): void;
  getColormapeffect(): ColormapEffect | undefined;
  setColormapeffect(value?: ColormapEffect): void;

  hasWindeffect(): boolean;
  clearWindeffect(): void;
  getWindeffect(): WindEffect | undefined;
  setWindeffect(value?: WindEffect): void;

  hasHologrameffect(): boolean;
  clearHologrameffect(): void;
  getHologrameffect(): HologramEffect | undefined;
  setHologrameffect(value?: HologramEffect): void;

  hasTerrainmapeffect(): boolean;
  clearTerrainmapeffect(): void;
  getTerrainmapeffect(): TerrainMapEffect | undefined;
  setTerrainmapeffect(value?: TerrainMapEffect): void;

  hasAgingeffect(): boolean;
  clearAgingeffect(): void;
  getAgingeffect(): AgingEffect | undefined;
  setAgingeffect(value?: AgingEffect): void;

  hasAvatareffect(): boolean;
  clearAvatareffect(): void;
  getAvatareffect(): AvatarEffect | undefined;
  setAvatareffect(value?: AvatarEffect): void;

  getEffectCase(): Effect.EffectCase;
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): Effect.AsObject;
  static toObject(includeInstance: boolean, msg: Effect): Effect.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: Effect, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): Effect;
  static deserializeBinaryFromReader(message: Effect, reader: jspb.BinaryReader): Effect;
}

export namespace Effect {
  export type AsObject = {
    watereffect?: WaterEffect.AsObject,
    colormapeffect?: ColormapEffect.AsObject,
    windeffect?: WindEffect.AsObject,
    hologrameffect?: HologramEffect.AsObject,
    terrainmapeffect?: TerrainMapEffect.AsObject,
    agingeffect?: AgingEffect.AsObject,
    avatareffect?: AvatarEffect.AsObject,
  }

  export enum EffectCase {
    EFFECT_NOT_SET = 0,
    WATEREFFECT = 1,
    COLORMAPEFFECT = 2,
    WINDEFFECT = 3,
    HOLOGRAMEFFECT = 4,
    TERRAINMAPEFFECT = 5,
    AGINGEFFECT = 6,
    AVATAREFFECT = 7,
  }
}

export class WaterEffect extends jspb.Message {
  getWavescale(): number;
  setWavescale(value: number): void;

  getWavespeed(): number;
  setWavespeed(value: number): void;

  getColor(): string;
  setColor(value: string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): WaterEffect.AsObject;
  static toObject(includeInstance: boolean, msg: WaterEffect): WaterEffect.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: WaterEffect, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): WaterEffect;
  static deserializeBinaryFromReader(message: WaterEffect, reader: jspb.BinaryReader): WaterEffect;
}

export namespace WaterEffect {
  export type AsObject = {
    wavescale: number,
    wavespeed: number,
    color: string,
  }
}

export class ColormapEffect extends jspb.Message {
  getNoisescale(): number;
  setNoisescale(value: number): void;

  getNoisecolor(): string;
  setNoisecolor(value: string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ColormapEffect.AsObject;
  static toObject(includeInstance: boolean, msg: ColormapEffect): ColormapEffect.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ColormapEffect, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ColormapEffect;
  static deserializeBinaryFromReader(message: ColormapEffect, reader: jspb.BinaryReader): ColormapEffect;
}

export namespace ColormapEffect {
  export type AsObject = {
    noisescale: number,
    noisecolor: string,
  }
}

export class WindEffect extends jspb.Message {
  clearDirectionList(): void;
  getDirectionList(): Array<number>;
  setDirectionList(value: Array<number>): void;
  addDirection(value: number, index?: number): number;

  getAmplitude(): number;
  setAmplitude(value: number): void;

  getFrequency(): number;
  setFrequency(value: number): void;

  getStartingpoint(): number;
  setStartingpoint(value: number): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): WindEffect.AsObject;
  static toObject(includeInstance: boolean, msg: WindEffect): WindEffect.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: WindEffect, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): WindEffect;
  static deserializeBinaryFromReader(message: WindEffect, reader: jspb.BinaryReader): WindEffect;
}

export namespace WindEffect {
  export type AsObject = {
    directionList: Array<number>,
    amplitude: number,
    frequency: number,
    startingpoint: number,
  }
}

export class HologramEffect extends jspb.Message {
  getSpeed(): number;
  setSpeed(value: number): void;

  getNoisetype(): NoiseTypeMap[keyof NoiseTypeMap];
  setNoisetype(value: NoiseTypeMap[keyof NoiseTypeMap]): void;

  clearDirectionList(): void;
  getDirectionList(): Array<number>;
  setDirectionList(value: Array<number>): void;
  addDirection(value: number, index?: number): number;

  getGlowcolor(): string;
  setGlowcolor(value: string): void;

  getOpacity(): number;
  setOpacity(value: number): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): HologramEffect.AsObject;
  static toObject(includeInstance: boolean, msg: HologramEffect): HologramEffect.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: HologramEffect, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): HologramEffect;
  static deserializeBinaryFromReader(message: HologramEffect, reader: jspb.BinaryReader): HologramEffect;
}

export namespace HologramEffect {
  export type AsObject = {
    speed: number,
    noisetype: NoiseTypeMap[keyof NoiseTypeMap],
    directionList: Array<number>,
    glowcolor: string,
    opacity: number,
  }
}

export class TerrainMapEffect extends jspb.Message {
  getMapscale(): number;
  setMapscale(value: number): void;

  getNoisescale(): number;
  setNoisescale(value: number): void;

  getNoisecolor(): string;
  setNoisecolor(value: string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): TerrainMapEffect.AsObject;
  static toObject(includeInstance: boolean, msg: TerrainMapEffect): TerrainMapEffect.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: TerrainMapEffect, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): TerrainMapEffect;
  static deserializeBinaryFromReader(message: TerrainMapEffect, reader: jspb.BinaryReader): TerrainMapEffect;
}

export namespace TerrainMapEffect {
  export type AsObject = {
    mapscale: number,
    noisescale: number,
    noisecolor: string,
  }
}

export class AgingEffect extends jspb.Message {
  getAgetexturefac(): number;
  setAgetexturefac(value: number): void;

  hasAgingtexture(): boolean;
  clearAgingtexture(): void;
  getAgingtexture(): TextureMap | undefined;
  setAgingtexture(value?: TextureMap): void;

  getFadecolor(): string;
  setFadecolor(value: string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): AgingEffect.AsObject;
  static toObject(includeInstance: boolean, msg: AgingEffect): AgingEffect.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: AgingEffect, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): AgingEffect;
  static deserializeBinaryFromReader(message: AgingEffect, reader: jspb.BinaryReader): AgingEffect;
}

export namespace AgingEffect {
  export type AsObject = {
    agetexturefac: number,
    agingtexture?: TextureMap.AsObject,
    fadecolor: string,
  }
}

export class AvatarEffect extends jspb.Message {
  getActive(): boolean;
  setActive(value: boolean): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): AvatarEffect.AsObject;
  static toObject(includeInstance: boolean, msg: AvatarEffect): AvatarEffect.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: AvatarEffect, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): AvatarEffect;
  static deserializeBinaryFromReader(message: AvatarEffect, reader: jspb.BinaryReader): AvatarEffect;
}

export namespace AvatarEffect {
  export type AsObject = {
    active: boolean,
  }
}

export class ContentMetadata extends jspb.Message {
  hasStaticcontentcid(): boolean;
  clearStaticcontentcid(): void;
  getStaticcontentcid(): UCSObjectId | undefined;
  setStaticcontentcid(value?: UCSObjectId): void;

  getName(): string;
  setName(value: string): void;

  getCategory(): string;
  setCategory(value: string): void;

  clearTagsList(): void;
  getTagsList(): Array<string>;
  setTagsList(value: Array<string>): void;
  addTags(value: string, index?: number): string;

  getDescription(): string;
  setDescription(value: string): void;

  hasPreview(): boolean;
  clearPreview(): void;
  getPreview(): TextureMap | undefined;
  setPreview(value?: TextureMap): void;

  hasLargepreview(): boolean;
  clearLargepreview(): void;
  getLargepreview(): TextureMap | undefined;
  setLargepreview(value?: TextureMap): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ContentMetadata.AsObject;
  static toObject(includeInstance: boolean, msg: ContentMetadata): ContentMetadata.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ContentMetadata, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ContentMetadata;
  static deserializeBinaryFromReader(message: ContentMetadata, reader: jspb.BinaryReader): ContentMetadata;
}

export namespace ContentMetadata {
  export type AsObject = {
    staticcontentcid?: UCSObjectId.AsObject,
    name: string,
    category: string,
    tagsList: Array<string>,
    description: string,
    preview?: TextureMap.AsObject,
    largepreview?: TextureMap.AsObject,
  }
}

export class SampledAnimationToViews extends jspb.Message {
  clearAnimationparametersList(): void;
  getAnimationparametersList(): Array<AnimationParameter>;
  setAnimationparametersList(value: Array<AnimationParameter>): void;
  addAnimationparameters(value?: AnimationParameter, index?: number): AnimationParameter;

  clearAnimationparametersvaluesList(): void;
  getAnimationparametersvaluesList(): Array<AnimationParametersValues>;
  setAnimationparametersvaluesList(value: Array<AnimationParametersValues>): void;
  addAnimationparametersvalues(value?: AnimationParametersValues, index?: number): AnimationParametersValues;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): SampledAnimationToViews.AsObject;
  static toObject(includeInstance: boolean, msg: SampledAnimationToViews): SampledAnimationToViews.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: SampledAnimationToViews, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): SampledAnimationToViews;
  static deserializeBinaryFromReader(message: SampledAnimationToViews, reader: jspb.BinaryReader): SampledAnimationToViews;
}

export namespace SampledAnimationToViews {
  export type AsObject = {
    animationparametersList: Array<AnimationParameter.AsObject>,
    animationparametersvaluesList: Array<AnimationParametersValues.AsObject>,
  }
}

export class AnimationParameter extends jspb.Message {
  getName(): string;
  setName(value: string): void;

  getMinvalue(): number;
  setMinvalue(value: number): void;

  getMaxvalue(): number;
  setMaxvalue(value: number): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): AnimationParameter.AsObject;
  static toObject(includeInstance: boolean, msg: AnimationParameter): AnimationParameter.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: AnimationParameter, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): AnimationParameter;
  static deserializeBinaryFromReader(message: AnimationParameter, reader: jspb.BinaryReader): AnimationParameter;
}

export namespace AnimationParameter {
  export type AsObject = {
    name: string,
    minvalue: number,
    maxvalue: number,
  }
}

export class AnimationParametersValues extends jspb.Message {
  clearParametervaluesList(): void;
  getParametervaluesList(): Array<number>;
  setParametervaluesList(value: Array<number>): void;
  addParametervalues(value: number, index?: number): number;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): AnimationParametersValues.AsObject;
  static toObject(includeInstance: boolean, msg: AnimationParametersValues): AnimationParametersValues.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: AnimationParametersValues, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): AnimationParametersValues;
  static deserializeBinaryFromReader(message: AnimationParametersValues, reader: jspb.BinaryReader): AnimationParametersValues;
}

export namespace AnimationParametersValues {
  export type AsObject = {
    parametervaluesList: Array<number>,
  }
}

export class BlockCells extends jspb.Message {
  clearIndexesList(): void;
  getIndexesList(): Array<number>;
  setIndexesList(value: Array<number>): void;
  addIndexes(value: number, index?: number): number;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): BlockCells.AsObject;
  static toObject(includeInstance: boolean, msg: BlockCells): BlockCells.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: BlockCells, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): BlockCells;
  static deserializeBinaryFromReader(message: BlockCells, reader: jspb.BinaryReader): BlockCells;
}

export namespace BlockCells {
  export type AsObject = {
    indexesList: Array<number>,
  }
}

export interface SideMap {
  FRONT: 0;
  BACK: 1;
  BOTH: 2;
}

export const Side: SideMap;

export interface MaterialBlendingMap {
  OPAQUE: 0;
  ALPHA_CLIP: 1;
  ALPHA_BLEND: 2;
}

export const MaterialBlending: MaterialBlendingMap;

export interface TexFormatMap {
  PNG: 0;
  ETC2: 1;
  BASISU_UASTC: 2;
  BC3: 3;
  BASISU_ETC1S: 4;
}

export const TexFormat: TexFormatMap;

export interface NoiseTypeMap {
  PERLIN: 0;
  WHITE: 1;
}

export const NoiseType: NoiseTypeMap;

